<?php	  
	/** 
	* This page receives the action from the "carriers_list" page or the "carriers_data" page.
	* In any case parameters are received through a HTML FORM, hence data are retrieved using the POST method.
	* Records chosen by the user are stored in INPUT fields named "record<n>": if the field is ON,
	* the "n-th" record has been selected. Then, two possibile pages can be targeted from here:
	*
	* - carriers_update.php: if the user chooses to modify the carrier (single record).
	* - carriers_delete.php: if the user chooses the delete the carrier (multiple selection).
	*
	*  In the first case data are passed through the HTTP request (GET method), in the second case data are passed
	*  as hidden INPUT fields of the HTML form, then the POST method will be involved.
	*/

	include '../include/session_header.php' ; 		// Including pages that take care of the session and database  
	include '../include/database_header.php' ;		// Managing database connections
	include '../include/users_DAO.php' ;			// Including pages managing the customers table (DBA layer)    
	include '../include/carriers_DAO.php' ;			// Including pages managing the carriers table (DBA layer)
	include '../include/display_header.php' ;		// Defining layout, images and loading the left menu  
	
	// REFACTORED (04-12-2012)
	$carriersName		= getCarriersHeaders() ;
?>
  
<script language="JavaScript">
function postForm() { document.deleteForm.submit() ; }
// Appending the users CSS at run-time
linkElement 		= document.createElement("link") ;
linkElement.rel 	= "stylesheet" ;
linkElement.href 	= "../css/carriers.css" ;
document.head.appendChild(linkElement) ;
// jQuery section
$(document).ready( function() {
	$('#carriers_table tr:odd').addClass('td_odd') ;
	$('#carriers_table tr:even').addClass('td_even') ;
	$('#carriers_table tr:first').removeClass('td_even') ;
}) ;
</script>
  
<?php
	// 1. Recognizing the action selected by the user
	if ( isset($_SESSION['USER_VIEW']) ) 	$mode 		= $_SESSION['USER_VIEW'] ;
	else									$mode 		= 1 ;
	if (isset($_POST['quest'])) 			$quest		= $_POST['quest'] ; 
	else 									$quest 		= 1 ;
	if 		($quest == 1) 					$operation 	= "MODIFICA" ;
	elseif 	($quest == 2) 					$operation 	= "CONFERMA CANCELLAZIONE" ;
  
	// 2. Customizing table layout
	$delta 		= 20 ;
	$columns 	= 8 ;
	$span 		= $columns + 1 ;
	include 	'../include/carriers_labels.php' ;
	print 		"<p class='td_carriers_title'>$operation $labelTitle</p>" ;
   
	// 3. Identifying which records are affected by the operation
	$index 	= 0 ;
	$chosen = array() ;
	foreach ($_POST as $row => $value) if ($value == "on") {
		$begin = substr($row,0,5) ;
		if ($begin != "field") {
			$chosen[$index] = substr($row,6) ;
			$index++ ;
		}
	}
	// Keep for testing or debug
	//print_r(array_values($chosen)) ;
  
	// 4. Printing table only if data are available
	$total = count($chosen) ;
	if ($total >= 1) {
?>

<div id="carriers_table">
<table>
<tr><td class="td_carriers_title" colspan="<?php print "$span" ?>"><?php print "$labelName SELEZIONATE ($total)" ?></td></tr>
<tr>

<!-- Form is used only if the user chooses the "delete" option. -->
<form name="deleteForm" action="carriers_delete.php" method="post">

<?php
	// PRINTING CARRIERS TABLE	
    // 1. Printing table headers, assigning "td width" considering field's length from the database
    foreach($carriersName as $index => $caption) {
        $width = $delta*($carriersWidth[$index]) ;
        print "\t<td width='$width px' class='td_carriers_header'>$caption</td>\n" ;
		// Keep for testing or debug
		// print "\t<td width='$width px' class='td_carriers_header'>$index-$carriersWidth[$index]</td>\n" ;
    }
    print "\t<td Class='td_carriers_header'>Status</td>\n" ;
    print "</tr>" ;
    // 2. Tracking selected records (if DELETE option)
    if ($quest == 2) foreach ($chosen as $value) print "\t<input type='hidden' name='record$value' value='yes'>\n" ;
    // 3. Printing values 
    $line = 0 ;
    $recordSet = getCarriersSelection($chosen) ;
	while ($row = mysql_fetch_array($recordSet, MYSQL_ASSOC)) {
		$index = 0 ;
		$line += 1 ;
		// Remark: the setting MYSQL_ASSOC is case-sensitive (with respect of the SQL statement)
		$code = $row["shipment_nr"] ;
		print "<tr>\n" ;
		foreach ($row as $value) {
			$width = $delta*($carriersWidth[$index]) ;
			if (isset($carriersName[$index])) {
				if 		($carriersName[$index] == "Mittente") 		$value = getCustomerName($value) ;
				elseif	($carriersName[$index] == "Destinatario") 	$value = getCustomerName($value) ;
				elseif	($carriersType[$index] == "date") 			$value = formatDate($value) ; 
				print "\t<td width='$width px' class=''>$value</td>\n" ;
			}
			$index += 1 ;
		}
		// Calculating status for current row
		$delivered 	= formatDate($row["delivery_date"]) ;
		$pendent 	= isDelivered($delivered) ;
		$textValue 	= ($pendent == 1)?"Attesa":"OK" ;
		print "<td class=''>$textValue</td>\n";
		print "</tr>\n";
    } // End of while
?>

</table>
</div>

<br/>

<?php
	// Managing the selection (quest = 1 --> UPDATE, quest = 2 --> DELETE)
	print "\t<p class='td_carriers_title'>" ;
	if ( ($total > 1 ) && ($quest == 1)	)	print "\t<span class='error'>Sono stati selezionate troppe $label_02: &egrave; necessario modificare una $label_01 alla volta!</span>" ;
	if ( ($total == 1) && ($quest == 1)	) 	print "\t<a class='confirm' href='carriers_data.php?code=$chosen[0]'>$operation</a>\n" ;
	if (  $quest == 2					) 	print "\t<a class='confirm' href='#' onclick='postForm()' title='$operation'>$operation</a>\n" ;
	print "\t</p>\n" ;
?>

<!-- If the target is "carriers_delete.php", data are passed within the form -->
<input type="hidden" name="quest" value="<?php print "$quest" ; ?>">

<?php
	// end of "if ($total >= 1)..."
	} else  {
		print "\t<p class='td_carriers_title'>" ;
		print "\t<span class='error'>Non &egrave; stata selezionata alcuna $label_01!</span>" ;
		print "\t</p>\n" ;
	}
	releaseAll() ;
?>

</form>

<br/><?php include 'carriers_goback.php' ;  ?><br/>

<?php include '../include/display_footer.php' ?>