<?php

	/** This page shows the carriers personal sheet for a single carrier.
	*  Two pages can be targeted from here:
	*	- carriers_update.php: if the user confirms the values written in the INPUT fields.
	* 	- carriers_confirm.php: if the user chooses to delete the current record.
	*
	*  In both cases data are passed as INPUT fields of the HTML form, then the POST method is involved, 
	*  but the ACTION value of the HTML form is changed on the fly to redirect the page (JavaScript).
	*/

	include '../include/session_header.php'; 	// Including pages that take care of the session and paging
	include '../include/database_header.php' ;	// Managing database connections
	include '../include/users_DAO.php';			// Including pages managing the customers table (DBA layer)    
	include '../include/carriers_DAO.php';		// Including pages managing the carriers table (DBA layer)
	include '../include/display_header.php' ;	// Defining layout, images and loading the left menu  
	include '../include/array_header.php' ;		// Creating javascript arrays for "dynamic menu's".
	
	// 1. Recognizing the action selected by the user.
	$rows 		= 16 ;
	$columns 	= 2 ;
	$labelSize 	= 135 ;
	$isAdmin 					= ($_SESSION[$logStatus] == 0) ;
	if (isset($_GET['code'])) 	$code = $_GET['code'] ; 
	else 						$code = - 1 ;
	if ($code > 0) 				$operation = "DATI" ; 
	else 						$operation = "INSERIMENTO" ;
	
	// 2. Customizing table layout
	include '../include/carriers_labels.php' ;
	print "<p class='td_carriers_title'>$operation $labelTitle</p>" ;
?>
  
<script language="JavaScript">
function postForm(number) {
	if (number == 1) { 
		num = document.update.field0 ;
		mit = document.update.field3 ;
		des = document.update.field4 ;
		dat = document.update.field13 ;
		if (num.value == "") { alert("E' necessario assegnare un numero di codice!") ; 					num.focus();	return false ;  }
		if (num.value <= 0)  { alert("Il codice della spedizione deve essere un numero positivo!") ; 	num.focus() ;	return false ;	}
		if (mit.value == "") { alert("Specificare il mittente!") ; 										mit.focus() ;	return false ; 	}
		if (des.value == "") { alert("Specificare il destinatario") ; 									des.focus();	return false ; 	}
		if (dat.value == "") { alert("Specificare la data dell'appuntamento!") ; 						dat.focus() ;	return false ; 	}
		document.update.quest.value = number ; 
		document.update.action = "carriers_update.php" ;
	}
	if (number == 2) { 
		document.update.quest.value = number ; 
		document.update.action = "carriers_confirm.php" ;
	}
}
// Changing all address fields (only if the user set a new recipient)
function getAddress(which) {
	if (which == 4) { 
		if ( confirm("Vuoi aggiornare l'indirizzo della spedizione?") ) {
			index = document.update.field4.value ;
			document.update.field5.value = address[index] ;
			document.update.field6.value = town[index] ;
			document.update.field7.value = province[index] ;
		}
	}
}
// Appending the users CSS at run-time
linkElement 		= document.createElement("link") ;
linkElement.rel 	= "stylesheet" ;
linkElement.href 	= "../css/carriers.css" ; 
document.head.appendChild(linkElement) ;
// jQuery section
$(document).ready( function() {
	// A) SELECT FIELDS
	// A.1 When page is just loaded we don't want to show the select fields
	$('.lookup_list').hide() ;
	// A.2 Showing select fields when they receive focus
	$('.lookup_data').focus( function() {
		$(this).hide() ;
		$(this).prev().show() ;
	}) ;
	// A.3 Hiding select fields when they loose focus
	$('.lookup_list').blur( function() {
		$(this).hide() ;
		$(this).next().show() ;
	}) ;
	// A.4 Bug-fixing: for some weird reason the above blur() handler does not intercept all blur events
	// --> we need to intercept focus on other fields in order to acknoledge such "uncaught" blur events
	$('input:not(.lookup_data)').focus( function() {
		$('.lookup_list').hide() ;
		$('.lookup_data').show() ;
	}) ;
	// A.5 When we change the select value, we must update also the "twin" field!
	$('.lookup_list').change(function() {
		var option = "option[value='" + $(this).val() + "']" ;
		var value = $(this).find(option).text() ;
		$(this).next().val(value) ;
	}) ;
	// B) Filling form with default values (keep for testing or debug)
	$('.icon').click( function() {
		$('input[name*="field"]').each( function() {
			var n = this.name.substr(5,7) ;
			if (this.value.length == 0) {
				if ( (n == 2) || (n == 9) ||  (n == 12) ||  (n == 13) ||  (n == 14) )	this.value = '31/12/2020' ;
				else 																	this.value = 'Foo' + n ;
			}
		}) ;
	}) ;
	// C) Adding date picker
	$('.input_date').datepicker({
		"dateFormat" 	: "dd/mm/yy" ,
		"showAnim"		: "slideDown" 
	}) ;
}) ;
</script>

<table id="carrier_data" border="0px">
<tr>
  <td class="td_carriers_title" colspan="<?php print "$columns" ?>">
  SCHEDA <?php print $labelTitle ?>
  <img class="icon" src="../images/icons/fill_default.gif" title="Fill with default data" alt="Default data"/>
  </td>
</tr>
  
<form name="update" method="post">
  
<?php
	// Setting common parameters
	$hash = getCustomersTable() ;
  
	// Case 1: printing values of the carrier (EDIT)
	if ($code > 0) {
		$lines = 0 ;
		$recordSet = getCarrier($code) ;
		while ($row = mysql_fetch_array($recordSet, MYSQL_BOTH)) {
			$lines += 1 ;
			$delivered 	= formatDate($row["delivery_date"]) ;
			$pendent 	= isDelivered($delivered) ;
			for ($index = 0; $index < $rows ; $index++) {
				$theValue = $row[$index] ;
				// Parsing data and looking up foreign keys
				if 		($carriersLongName[$index] == "Mittente") 		$theValue = getCustomerName	( $row[$index] ) ;
				elseif 	($carriersLongName[$index] == "Destinatario") 	$theValue = getCustomerName	( $row[$index] ) ;
				elseif 	($carriersType[$index] == "date") 				$theValue = formatDate		( $row[$index] ) ;
				print "<tr>\n" ;
				print "\t<td class='td_carriers_label'>&nbsp;$carriersLongName[$index]</td>\n" ;
				// Keep for testing or debug
				// print "\t<td class='td_carriers_label'>$index-$carriersLongName[$index]" ;
				print "\t<td class='td_carriers_data'>" ;
				// ADMINISTRATORS fields format: can edit all fields
				if ($isAdmin) {
					// Ordinary input fields
					if ( ($index != 3) && ($index != 4) ) {
						if ($carriersType[$index] == "date")	$class = "td_carriers_input input_date" ;
						else									$class = "td_carriers_input" ;
						print "<input type='textbox' class='$class' name='field$index' value='$theValue'/>" ;
					// Drop down menu (select combo-box)
					// REMARK: DO NOT CHANGE order of these fields, since they are referred by jQuery
					} else {
						print "<select class='lookup_list' name='field$index' onchange='getAddress($index)'>" ;
						print lookupCustomers($row[$index], $hash[0]) ;
						print "</select>" ;
						print "<input type='textbox' class='td_carriers_input lookup_data' value='$theValue'/>" ;
					}
				// ORDINARY USERS fields format: can edit only few fields
				// Remark: we need the "name=field<n>" input anyway (to have a standard POST numbered order)
				} else {
					// If already delivered the user cannot edit any fields
					if (!$pendent) {
						print "<span class='td_carriers_input'>$theValue</span>" ;
						print "<input type='hidden' name='field$index' value='$theValue'/>" ;
					// If not delivered yet, the user can edit just two fields: planned date and notes
					} else {
						if ($index == 13) {
							print "<input type='textbox' class='td_enabled_input input_date' name='field$index' value='$theValue'/>" ;
						} elseif ($index == 15) {
							print "<input type='textbox' class='td_enabled_input' name='field$index' value='$theValue'/>" ;
						} else {
							print "<span class='td_carriers_input'>$theValue</span>" ;
							print "<input type='hidden' name='field$index' value='$theValue'/>" ;
						}
					}
				}
				print "</td>\n" ;
				print "</tr>\n";
			} // End of for
		} // End of while
		print "<tr>\n" ;
		print "\t<td colspan='2'><p class='carriers_footer'>&nbsp;" ;
		if ($pendent) 	print "<span class='undelivered'>Spedizione ancora da effettuare</span>" ; 
		else 			print "<span class='delivered'>Spedizione gi&agrave; consegnata</spans>" ;
		print "</p></td>\n" ;
		print "</tr>\n";    
	} // End of "if ($code > 0) ..."
  
	// Case 2: inserting new carrier (INSERT)
	else {
		$nextCode = getMaxCarrier() + 1 ;
		for ($index = 0; $index < $rows ; $index++) {
			print "<tr>\n" ;
			// print "\t<td class='td_carriers_label'>&nbsp;$carriersLongName[$index]</td>" ;
			// Keep for testing or debug
			print "\t<td class='td_carriers_label'>$index-$carriersLongName[$index]</td>" ;
			print "\t<td class='td_carriers_data'>" ;
			if ($index == 0) {
				print "<input type='textbox' class='td_carriers_input' name='field$index' value='$nextCode'>" ;
			} 
			elseif (($index == 3) || ($index == 4)) {
				print "<select class='td_carriers_input' name='field$index' onchange='getAddress($index)'>" ;
				print lookupCustomers(0, $hash[0]) ;
				print "</select>" ;
			} else {
				if ($carriersType[$index] == "date")	$class = "td_carriers_input input_date" ;
				else									$class = "td_carriers_input" ;
				print "<input type='textbox' class='$class' name='field$index'>" ;
			}
			print "</td>\n" ;
			print "</tr>\n" ;
		}
	}

	// 3. Releasing resources
	releaseAll() ;
?>

</table>

<br/>

<!-- If the target is "carriers_update", data are passed within the form -->
<input type="hidden" name="quest" value="0">
<input type="hidden" name="code" value="<?php print "$code" ?>">
<!-- If the target is "carriers_confirm", different data are passed within the form -->
<input type='hidden' name='record<?php print $code ; ?>' value='on'>

<nav class="carrierdata_nav">
<table class="centered"> 
  <tr>
    <td class="td_carriers_action">
		<a href="carriers_list.php?page=1"><input type="button" value="Annulla l'operazione" title="Annulla l'operazione"></a>
    </td>
<?php     
	// Deciding if to show the "edit" option
	if ($isAdmin || $pendent) {
		print "<td class='td_carriers_action'>" ;
		print "<input type='submit' onclick='return postForm(1);' value='Conferma le modifiche' title='Conferma le modifiche'>" ;
		print "</td>" ;
	}
    // Deciding if to show the "delete" option
    print "<td class='td_carriers_action'>" ;
    if ($isAdmin) {
      if ($code > 0) {
		print "\t<input type='submit' onclick='postForm(2);' value='Cancella $label_01' title='Cancella $label_01'>\n" ;
      } 
    }
    print "</td>" ;
?>
  </td>
  </tr>
</table>
</nav>
    
</form>

<?php include '../include/display_footer.php' ?>