<?php
	/**
	* This page receives the action from the "carriers_data" page.
	* In any case parameters are received through a HTML FORM, hence data are retrieved using the POST method:
	* values written by the user are stored in INPUT fields named "field<n>".
	* This page retrieves all the input parameters and executes the UPDATE or INSERT statement, then shows
	* the result of the operation.
	*/

	include '../include/session_header.php' ; 		// Including pages that take care of the session and database
	include '../include/database_header.php' ;		// Managing database connections
	include '../include/users_DAO.php' ;			// Including pages managing the customers table (DBA layer)
	include '../include/carriers_DAO.php' ;			// Including pages managing the carriers table (DBA layer)
	include '../include/display_header.php' ;		// Defining layout, images and loading the left menu
?>

<script language="JavaScript">
// Appending the users CSS at run-time
linkElement 		= document.createElement("link") ;
linkElement.rel 	= "stylesheet" ;
linkElement.href 	= "../css/carriers.css" ;
document.head.appendChild(linkElement) ;
// jQuery section (placeholder)
// $(document).ready( function() { }) ;
</script>

<?php
	// 1. Recognizing the action selected by the user (HTML FORM)
	if (isset($_POST['code'])) 				$code = $_POST['code'] ;		// Code of carrier
	if (isset($_POST['quest'])) 			$quest = $_POST['quest'] ;		// Type of operation
	if ( isset($_SESSION['USER_VIEW']) ) 	$mode = $_SESSION['USER_VIEW'] ;
	else									$mode = 1 ;
	if 		($code == 0) 					$operation = "INSERIMENTO" ;
	elseif ($quest == 1) 					$operation = "MODIFICA" ;
	//print_r(array_values($_POST)) ;

	// 2. Customizing table layout
	$rows 		= 16 ;
	$columns 	= 2 ;
	$span 		= $columns + 1 ;
	$isAdmin 	= ($_SESSION[$logStatus] == 0) ;
	include 	'../include/carriers_labels.php' ;
	print 		"<p class='td_carriers_title'>$operation $labelTitle</p>" ;
	print 		"<br/>" ;

	// 3. Popolating the "$values" array with data from the POST HTTP (filtered)
	$values = array() ;
	foreach ($_POST as $row => $value) {
		$index = substr($row,5,6) ;
		if (substr($row,0,5) == "field") {
			if ($carriersType[$index] == "date") 	$values[$index] = setDate($value) ;
			else 									$values[$index] = $value ;
			// Keep for testing or debug
			// print "Received $row ($index) = $value<br/>" ;
			// print $carriersLongName[$index]."-".$values[$index]) ;
		}
	}

	// 4. Checking input parameters: see "carriers_DAO.php" 
	$check = validateCarrier($values) ;
	if ($check[0] == 0) {
		print "<div class='carriers_update_response'>" ;
		print "<p class='error'>I valori inseriti non sono corretti: ripetere l'operazione.</p>" ;
		print "<p>Per consultare le condizioni di modifica delle spedizioni clicca " ;
		print "<a class='help_link' href='../help/update_help.php'>qui</a>.</p>" ;
		print "<br/><br/>" ;
		print "<a class='carriers_query_link' href='carriers_data.php?code=$code'>Torna indietro</a>" ;
		print "</div>" ;
		die() ;
	}

	// 5. Updating carriers'data in the database
	if 			($code == 0) 						$done = insertCarrier($values) ;
	elseif 	( 	($quest == 1) && ( $isAdmin )	)	$done = updateCarrier($code, $values) ;
	elseif 	( 	($quest == 1) && (!$isAdmin )	)	$done = modifyCarrier($code, $values) ;
	$error = mysql_errno() ;

	// 6. Showing result of the operation
	print "<div class='carriers_update_response'>" ;
	if (($error == 0) && ($done == TRUE)) {
		$notified = 0 ;
		$hash = getCustomersTable() ;
		print "<p>Operazione eseguita con successo</p>" ;
		// Refreshing page numbers
		formatPage($mode, "", "carriers") ;
		// Getting mail data
		if ($code > 0) 	$recordSet = getCarrier($code) ; 
		else 			$recordSet = getCarrier($values[0]) ;
		$newValues = mysql_fetch_row($recordSet) ;
		// Sending mail notification
		if ($code > 0) {
			$notified = notifyByMail($newValues, 1, $hash, TRUE) ;
			if ($notified == 1) print "<p>La modifica &egrave stata notificata via mail</p>" ;
			else 				print "<p class='error'>ATTENZIONE! Non &egrave; stato possibile inviare la mail di notifica!</p>" ;
			print "<p>(<a Class='help_link' href='../help/mail_preview.php?code=$code&type=1'>dettagli</a>)</p>" ;
		}
	}
	else print "<p>Si &egrave; verificato un problema tecnico: operazione fallita.</p>" ;
	print "</div>" ;
	print "<br/>" ;
?>

<table id="carrier_data">
<tr>
  <td class="td_carriers_title" colspan="<?php print "$span" ?>">
  SCHEDA <?php print $labelTitle ; ?>
  </td>
</tr>

<?php
	// 7. Showing modification
	$lines = 0 ;
	if ($code > 0) 	$recordSet = getCarrier($code) ;
	else 			$recordSet = getCarrier($values[0]) ;
	while ($row = mysql_fetch_array($recordSet, MYSQL_BOTH)) {
		$lines += 1 ;
		for ($index = 0; $index < $rows ; $index++) {
			print "<tr>\n" ;
			print "\t<td class='td_carriers_label'>&nbsp;$carriersLongName[$index]</td>\n" ;
			print "\t<td class='td_carriers_data'>" ;
			if 		($carriersLongName[$index] 	== "Mittente"		) 	$value = getCustomerName($row[$index]) ;
			elseif 	($carriersLongName[$index] 	== "Destinatario"	) 	$value = getCustomerName($row[$index]) ;
			elseif 	($carriersType[$index] 		== "date"			) 	$value = formatDate($row[$index]) ;
			else 														$value = $row[$index] ;
			print "&nbsp;$value" ;
			print "</td>\n" ;
			print "</tr>\n";
		}
	} // End of while
	releaseAll();
?>

</table>

<br/><?php include 'carriers_goback.php' ;  ?><br/>

<?php include '../include/display_footer.php' ?>