<?php
/**
* The User Data Access Object class, bound to the UserVO class (see "UserVO.php").
*/
class UserDAO {

	private $connection ;
	
/********************************************************************************************
/****************************			CONSTRUCTORS				*************************
/********************************************************************************************

	/**
	* Basic constructor 					
	*/
	function UserDAO(&$connection) {

		$this->connection = &$connection ;
	}
	
/********************************************************************************************
/****************************			PUBLIC API (standard)		*************************
/********************************************************************************************
	
	/**
	* Insert or modify a user in the database.
	* If the input UserVO has ID = 0, we assume the user must be inserted,
	* otherwise, we modify the existing user (accessing the private API).
	*/
	function save(&$vo) {
		if ($vo->getID() == 0) {
			return $this->insert($vo) ;
		} else {
			return $this->update($vo) ;
		}
	}

	/**
	* Retrieves user data from the database using the deprecated PHP4 API. 
	* For the new API (PHP5) see the MySQLi or PDO_MySQL extensions.
	* Current implementaion relies on the MYSQL_NUM retrieve options: alternative
	* choices could be MYSQL_ASSOC (retrieve associative) or MYSQL_BOTH (numeric and associative).
	*/
	function get($id) {
		$query 		= "SELECT * FROM users WHERE code = " . $id ;
		$recordSet 	= mysql_query($query) or self::manageError($query) ;
		$array 		= mysql_fetch_array($recordSet, MYSQL_NUM) ;
		return		self::createVO($array) ;
	}
	
	/*
	* Delete an existing user.
	* Notice that current implementatation returns "1" also if no record is deleted from the database.
	* (check it by logging in the Apache error log file)
	*/
	function delete($id) {
		// 1. Create delete query
		$query  = "DELETE FROM users WHERE code = " . $id ;
		// 2. Delete record from the database
		$result = mysql_query($query) or self::manageError($query) ;
		// Keep for testing or debug
		// error_log("DAO QUERY: ".$query." (result:$result)") ;
		// 3. Returning result
		if ($result > 0) 	return $result ;
		else 				return mysql_error() ;
	}
	
/********************************************************************************************
/****************************			PUBLIC API (helper)			*************************
/********************************************************************************************
	
	/** Retrieve the customers maximum code number.						*/
	function getMaxUser() {

		$query  = "SELECT MAX(code) FROM users" ;
		$result = mysql_query($query) or self::manageError($query) ;
		$riga 	= mysql_fetch_row($result) ;
		return $riga[0] ;
	}
	
/********************************************************************************************
/****************************			PRIVATE API					*************************
/********************************************************************************************/
   
	// Factory method.
	private function createVO($result) {
	
		return new UserVO($result) ;
	}

	// Update an existing user.
	private function update(&$vo) {
	
		// 1. Getting user data
		$values 		= $vo->getAllData() ;
	
		// 2. Creating UPDATE query
		$query  = "UPDATE users SET name='$values[1]', surname='$values[2]', company='$values[3]', " ;
		$query .= "address='$values[4]', town='$values[5]', province='$values[6]', zip='$values[7]', " ;
		$query .= "country='$values[8]', telephone1='$values[9]', telephone2='$values[10]', mobile1='$values[11]', " ;
		$query .= "mobile2='$values[12]', fax='$values[13]', login='$values[14]', admin='$values[16]', notes='$values[17]'" ;
		// If the password field is empty we assume the user did not change it
		if ($values[15] != "") {
			$value = md5($values[15]) ;
			// Keep for testing or debug: insert CLEAR password (not encrypted)
			// $value = $values[15] ;
			$query .= ", pwd = '$value'" ;
		}
		$query .= " WHERE code = ".$values[0] ;
		// Keep for testing or debug
		// error_log("DAO QUERY: ".$query) ;

		// 3. Update record into database
		$result = mysql_query($query) or self::manageError($query) ;
		if ($result > 0) 	return $values[0] ;
		else 				return mysql_error() ;
	}

	/*
	* Insert a new user in the database.
	* If succesfull returns the new user ID.
	*/
	private function insert(&$vo) {
	
		// 1. Generates new user ID and set it the VO (also encrypting password)
		$values 		= $vo->getAllData() ;
		$values[0] 		= self::getMaxUser() + 1 ;
		$values[15]  	= md5($values[15]) ;
		$user 			= self::createVO($values) ;
		
		// 2. Creating INSERT query
		$query  = "INSERT INTO users (code, name, surname, company, address, town, province, zip, country, " ;
		$query .= "telephone1, telephone2, mobile1, mobile2, fax, login, pwd, admin, notes) " ;
		$query .= "VALUES('$values[0]','$values[1]','$values[2]','$values[3]','$values[4]', '$values[5]', ";
		$query .= "'$values[6]','$values[7]','$values[8]','$values[9]','$values[10]', '$values[11]', '$values[12]', ";
		$query .= "'$values[13]','$values[14]','$values[15]','$values[16]','$values[17]')" ;
		// Keep for testing or debug
		// error_log("DAO QUERY: ".$query) ;
		
		// 3. Insert record into database
		$result = mysql_query($query) or self::manageError($query) ;
		if ($result > 0) 	return $values[0] ;
		else 				return mysql_error() ;
	}
	
	/*
	* Manages SQL errors.
	* Current implentation just logs the error in the Apache error file.
	* On Windows (using easPHP) the error log could have a path like this:
	*
	* C:\Program Files (x86)\EasyPHP-5.3.8.1\apache\logs\error.log
	*/
	private function manageError($query) {
	
		error_log("SQL ERROR FOR: ".$query) ;
		//die("Query failed") ;
	}   
	
} // End of class
?>