<?php 
	/** 
	* This is the welcome page after the customer login (if succesfull), otherwise action is forwarded to the
	* "bad_data.php" page.
	* If the user does not try to login (i.e. guest user) action is forwarde to the "guest.php" page.
	* (see checkLogin() functon in the "session_header.php" page).
	*/
	
	// Setting relative URL references
	$root = '../' ;
	
	// Including PHP sections
	include $root.'include/session_header.php' ;								// Including pages that take care of the session 
	include $root.'include/database_header.php' ;								// Managing database connections (current way)
	// if (!isset($fromLogin)) include $root.'include/database_header.php' ;	// Managing database connections (old way)
	include $root.'include/display_header.php' ;								// Defining layout and loading the left menu (must be the 1st)
	include $root.'include/debug_header.php' ;									// Showing some data useful to debug the system.  
  
	// Defining source of authentication
	$allowLogin = true ;			// Use this to ask authentication within this site
	//$allowLogin = false ;			// Use this to force authentication from an "external" site (SSO)
	
	// Adjusting content with respect of current login status
	$welcomeLabel	= "BENVENUTO NELLA PHRACTICE WEB APPLICATION" ;
	$loggedIn 		= (isset($_SESSION[$logStatus])) && ($_SESSION[$logStatus] >= 0) ;
	if ($loggedIn) 	$showName = $_SESSION[$loggedName] ;
	else 			$showName = "Guest" ;
	$welcomeLabel = "Benvenuto ".$showName ;
	
	// Optionally forcing a new login
	if (isset($_GET["switchUser"])) $showLogin = true ;
	else 							$showLogin = $allowLogin && !$loggedIn ;
  
	// Keep for test or debug
	//echo 'MD5 = #'.md5('ciao').'#' ;
?>

<div class="content_01">

<h2><?php print $welcomeLabel ?></h2>
<p class="login_note"><a href="home.php?switchUser">Non sei <?php print $showName ; ?>?</a></p>

<p class="main_font">
L'applicazione Phractice  un software senza scopi pratici, nata con l'obiettivo di fornire del "materiale di addestramento", 
da utilizzare come strumento didattico o formativo. L'applicazione mostra un'esempio di implementazione di un gestionale per
corrieri espressi: ogni utente potrebbe essere uno spedizioniere oppure un destinatario.
</p>

<?php 	if ($showLogin) include 'login.php' ;	?>

<p class="main_font">
L'applicazione contiene inoltre alcune sezioni extra, utilizzabili come <a class="Help_Link" href="../test/test_php.php">tutorial</a> PHP.
</p>

<p>Per maggiori informazioni:</p>

<a class="Help_Link" href="../help/general_help.php">Istruzioni generali</a><br/>
<a class="Help_Link" href="../help/update_help.php">Come modificare i dati di una spedizione</a><br/>
<a class="Help_Link" href="../help/mail_help.php">Informazioni sulle notifiche via e-mail</a><br/>

<br/><br/>

<p class="centered" style="WIDTH:170px;">
<a href="../home/logout.php" title="Esci dall'applicazione">Termina il collegamento</a>
</p>

</div>

<br/><br/>

<?php include $root.'include/debug_footer.php' 		?>
<?php include $root.'include/display_footer.php' 	?>