<?php	  
	/** 
	* This page manages the connections to the DATABASE for the entire system.
	* Every hard-coded detail about the database must be specified here. In this way, if the
	* database structure is modified, it should be necessary to modify only this page (encapsulation concept).
	* 
	* IMPLEMENTATION GUIDELINES:
	*
	* The "$result" and "$recordSet" variables are GLOBAL VARIABLES, defined here in order to be available
	* in all pages including the "database_header.php":
	* - $result		:	MUST BE defined as GLOBAL into any function accessing the database (e.g. the xxxDAO classes),
	* 					since in this way the query's results can be release by the function "releaseAll()"
	* - $recordSet	:	MUST BE used within the PHP pages handling results of the DAO classes, for the same
	*					reason of the "$result" variable
	*/
	
	// 1. Checking that this page is reached coming from one of my pages, and not by typing something like:
	// http://dominio.com/sito/common/connect.php
	if (!defined('INCLUDE_CHECK')) die('You are not allowed to execute this file directly') ;

	// 2. Opening connections to the database.
	$result 	= array() ;
	$recordSet 	= array() ;
	$connection = mysql_connect("localhost", "root", "") or die("Connessione non riuscita") ;
	mysql_select_db("phractice") or die("Selezione del database non riuscita") ;
   
/******************************************************************************************/
/**********************			DATABASE RESOURCES		***********************************/
/******************************************************************************************/

  /** Releasing resources and closing the connection.							*/
  function releaseAll() {
  
    // We need to say "please, use global variables"
    global $connection, $result, $recordSet ;	
  
    if ($result != null) mysql_free_result($result) ;
    if ($recordSet != null) mysql_free_result($recordSet) ;
    if ($connection != null) mysql_close($connection) ;
  }

/******************************************************************************************/  
/**********************			  DATE & TIME 			***********************************/
/******************************************************************************************/

  /** Format the italian date (after a SELECT).<P>
   *  This is necessary because setlocale (LC_TIME, "it_IT") does nothing (in PHP), 
   *  and "SET date_format=%d%m%Y" does nothing (in MySQL).
   */
   function formatDate($dateValue) {
     
     $formatted = date("d/m/Y") ;
     if ($dateValue != null) {
       $ts = strtotime($dateValue, 0) ;
       if ($ts > 0) $formatted = date("d/m/Y", $ts) ;
       if ($formatted == "26/02/1970") $formatted = "Non indicata" ;
     }
     return $formatted ;
   }
 
  /** Set the english date (before an INSERT or UPDATE).<P>
   *  This is necessary because setlocale (LC_TIME, "it_IT") does nothing (in PHP), 
   *  and "SET date_format=%d%m%Y" does nothing (in MySQL).
   */
   function setDate($dateValue) {
    
    $formatted = "1970-02-26" ;
    if ($dateValue != null) {
      $ts = 0 ;
      $isGood = 0 ;
      $token = explode ("/", $dateValue) ;
      if (count($token) == 3) $isGood = ( checkdate($token[1],$token[0],$token[2]) && ($token[2] > 1970) );
      if ($isGood) $ts = mktime(0,0,0,$token[1],$token[0],$token[2]) ;
      if ($ts > 0) $formatted = date("Y-m-d", $ts) ;
      //print $dateValue . "(". $isGood . ")" ;
    }
    return $formatted ;
   } 

  /** Parse the input date (italian format) and return the timestamp.					*/ 
  function getTimestamp($dateValue) {
   
    $ts = 0 ;
    $isGood = 0 ;
    $token = explode ("/", $dateValue) ;
    if (count($token) == 3) $isGood = ( checkdate($token[1],$token[0],$token[2]) && ($token[2] > 1970) );
    if ($isGood) $ts = mktime(0,0,0,$token[1],$token[0],$token[2]) ;
    return $ts ;
  } 

/******************************************************************************************/
/**********************			MAIL NOTIFICATION		***********************************/
/******************************************************************************************/

	/** 
	* Notify to the administrator the carrier modifications.
	* Each time a shipment is modified an e-mail is send from this function: to avoid sending 
	* unformatted content to the user, before sending the e-mail the following function is invoked too:
	*
	* error_reporting(0)
	*
	* For this reason, during installation it could be useful to uncomment this line.
	*
	* @param values the array containing the carrier data
	* @param mode type of modification (0 = DELETE, 1 = UPDATE)
	* @param hash a 2D array containing all the users's data (used to lookup users's names)
	* @param send if FALSE the mail will not be send (used to preview the mail message)
	*/
	function notifyByMail($values, $mode, $hash, $send) {

		// Setting headers
		if ($mode == 1) $context = "Notifica di aggiornamento spedizione (rif. nr. ".$values[0]. ")" ;
		else 			$context = "Avviso di cancellazione spedizione (rif. nr. ".$values[0]. ")" ;
		$target 	= "Morpheus Quality Technologies <morpheus@adriani.altervista.org>" ; 
		$headers 	= "Morpheus Quality Technologies <morpheus@adriani.altervista.org>\r\n";
		$headers   .= "From: Phractice Daemon\r\n";
		//$headers .= "From: Doc Gonzo <docgonzo@yahoo.com>\r\n";
		//$headers .= "Cc: cyndi.lauper@virgin.com\r\n";
		//$headers .= "Bcc: docgoonzo@yahoo.com\r\n";
		
		// Composing the message
		$code = $values[0] ;
		$message  = "Buongiorno,\n\n" ;
		
		// We have data only if carrier was not deleted
		if ($mode == 1) {
			$message .= "\te' stata effettuata una modifica alla spedizione numero " . $code . ".\n\n" ;
			$message .= "Mittente: " . $hash[0][$values[3]] . "\n" ;
			$message .= "Destinatario: " . $hash[0][$values[4]] . "\n" ;
			$message .= "Data appuntamento: " . formatDate($values[13]) . "\n" ;
			if ($values[15] != "") $message .= "Note: " . $values[15] . "\n" ;
			$message .= "\n" ;
		}
		else $message .= "\te' stata cancellata la spedizione numero " . $code . ".\n\n" ;
		
		$message .= "Sistema automatico di gestione spedizioni Phractice\n" ;
		$message .= "(si prega di non rispondere a questa mail)" ;

		// Sending now    
		error_reporting (0) ;
		if ($send == TRUE) $result = mail($target, $context, $message, $headers); else $result = FALSE ;
		error_reporting (E_ALL) ; 

		if ($send == TRUE) return $result ; 
		else return array($target, $context, $message, $headers) ;
	}
?>