<?php
	/** 
	* This is the page (to be included in other page) that takes care of the session for GUEST users.
	* This page should be used only within the "test" section (containing some PHP tutorials for beginners).
	*/

	/** 
	* Starting session: session should start only here XOR in the "authenticate.php" page XOR "session_header.php" page
	* If these variables are modified, change also those defined in the "authenticate.php" page.
	*/
	// Starting session
	session_name('phractice');
	session_set_cookie_params(10*60);			// Making the cookie live for 10 minutes			
	session_start();
	
	// Minimal reference to actual session page (i.e. "session_header.php")
	// This is necessary to keep the left menu when user navigates the test section after a succesfull login.
	$logStatus = "status" ;
  
	// Session parameters
	$pageCounter = "counter" ;	// Used for statistics about the user
      
/***********************************************************************************************/ 
/**********************			SESSION MANAGEMENT		****************************************/
/***********************************************************************************************/ 

  /** Preserver the current session (could be useful if the user logs in later).				*/
  function setSession() {
    
    global $pageCounter ;
    
    // Providing statistics for this user 
    if (isset($_SESSION[$pageCounter])) $_SESSION[$pageCounter]++ ;
      else $_SESSION[$pageCounter] = 0 ;
  }

/***********************************************************************************************/ 
/**********************					PHP BODY			************************************/
/***********************************************************************************************/

  // We must start the session in every page of the system!
  setSession() ;
?> 