<?php
	/**
	* This page represents the CUSTOMERS Database Access Object (DAO) of the entire system.
	* Every hard-coded detail about the customers table must be specified here. In this way, if the
	* database is modified, it should be necessary to modify only this page (encapsulation concept).
	* This page contains following functions:
	*
	* SELECT QUERIES.
	* - countCustomers :
	* - getMaxCustomer :
	* - getCustomer :
	* - findCustomer :
	* - getUserData :
	* - isAdmin :
	* - getCustomerName :
	* - getCustomersList :
	* - getCustomersSelection :
	*
	* UPDATE QUERIES.
	* - updateCustomer :
	* - insertCustomer :
	* - deleteCustomers :
	*
	* UTILITIES.
	* - searchCustomers :
	* - getCustomersColumns
	* - getCustomersTable :
	*/
	
/**********************************************************************************************/
/**********************				STATIC ACCESSORS		***********************************/
/**********************************************************************************************/
	
	// Static field: use for testing or debug
	$customer_dao_debug = true ;
	
	/** Retrieve the labels for the users headers			*/
	function getCustomersHeaders() {
		$columns = array( 0=>"Nr.", 1=>"Nome", 2=>"Cognome", 3=>"Azienda", 4=>"Indirizzo", 5=>"Citt&agrave;", 6=>"Pr." ) ;
		return $columns ;
	}
	
	// TODO: refactor as above
	$customersLongName 	= array(
		"Codice","Nome","Cognome","Azienda","Indirizzo","Citt&agrave","Provincia",
		"CAP","Nazione","Telefono 1","Telefono 2","Cellulare 1","Cellulare 2",
		"Numero di Fax", "Login", "Password", "Amministratore", "Note"
	) ;

/**********************************************************************************************/
/**********************			SELECT QUERY METHODS		***********************************/
/**********************************************************************************************/

	/** Retrieve the number of records for the customers table					*/
	function countCustomers($admin, $where) {

		global $result ;

		$query  = "SELECT count(*) FROM users where " ;
		if ($admin == 0) 		$query .= "admin ='1' " ;
		elseif ($admin == 1) 	$query .= "(admin='0' or admin is null)" ;
		if ( ($admin < 2) && ($where != null) ) $query .= " AND " ;
		if ($where != null) 	$query .= $where ;
		// Keep for testing or debug
		//print "DAO query: $query<br/>" ;
		$result = mysql_query($query) or manageCustomerError() ;
		$riga = mysql_fetch_row($result) ;
		return $riga[0] ;
	}

	/** Retrieve the customers maximum code number.						*/
	function getMaxCustomer() {

		global $result ;

		$query  = "SELECT MAX(code) FROM users" ;
		$result = mysql_query($query) or manageCustomerError() ;
		$riga 	= mysql_fetch_row($result) ;
		return $riga[0] ;
	}

	/** Retrieve the customer data sheet.								*/
	function getCustomer($code) {

		global $result ;

		$query  = "SELECT code, name, surname, company, address, town, province, zip, country, " ;
		$query .= "telephone1, telephone2, mobile1, mobile2, fax, login, pwd, admin, notes " ;
		$query .= "FROM users WHERE code = " . $code;
		// Keep for testing or debug
		//print "DAO query: $query<br/>" ;
		$result = mysql_query($query) or manageCustomerError() ;
		return $result ;
	}

	/** Find the customer code given the name.							*/
	function findCustomer($name) {

		global $result ;

		$query = "SELECT code FROM users WHERE (name like '%$name%' OR surname like '%$name%' OR company like '%$name%')" ;
		$result = mysql_query($query) or manageCustomerError() ; 
		$riga = mysql_fetch_row($result) ;
		$value = $riga[0] ;
		if ($value == "") $value = -1 ;	// Otherwise the "search carriers" finds all customers!
		return $value ;
	}

	/**
	* Find the customer code given the login name.
	* Here we don't use mysql_fetch_assoc(), but we use the "rough" mysql_fetch_row() function instead,
	* for backward compatibility issues.
	*/
	function getUserData($login) {

		global 	$result ;
		$query 	= "SELECT code, login, pwd FROM users WHERE login = '" . $login . "'" ;
		$result = mysql_query($query) or manageCustomerError() ;
		$riga 	= mysql_fetch_row($result) ;
		return 	$riga ;
	}

	/** Tells if the customer has admin privilegies.						*/
	function isAdmin($code) {

		global $result ;

		$query = "SELECT * FROM users WHERE code = " . $code ;
		$result = mysql_query($query) or manageCustomerError() ;
		$riga = mysql_fetch_array($result, MYSQL_ASSOC) ;
		return $riga['admin'] ;
	}

	/** Retrieve the customer name.								*/
	function getCustomerName($code) {

		global $result ;

		$query 	= "SELECT company FROM users WHERE code = " . $code ;
		$result = mysql_query($query) or manageCustomerError() ;
		$riga 	= mysql_fetch_row($result) ;
		$value 	= $riga[0] ." [" . $code . "]" ;
		return $value ;
	}

	/** Retrieve the customers main data.								*/
	function getCustomersList($admin, $where, $limit, $start) {

		global $result ;

		$query  = "SELECT code, name, surname, company, address, town, province " ;
		$query .= "FROM users where " ;
		if ($admin == 0) $query .= "admin ='1' " ;
		elseif ($admin == 1) $query .= "(admin='0' or admin is null)" ;
		if ( ($admin < 2) && ($where != null) ) $query .= " AND " ;
		if ($where != null) $query .= $where ;
		$query .= " ORDER BY code " ;
		if ($start >= 0) $query .= "LIMIT " . $limit . " OFFSET " . $start ;
		// Keep for testing or debug
		//print "DAO query: $query<br/>" ;
		$result = mysql_query($query) or manageCustomerError() ;
		return $result ;
	}

	/** Retrieve the customers identified by the input array (MULTIPLE DELETE)			*/
	function getCustomersSelection($selection) {

		global $result ;

		$query  = "SELECT code, name, surname, company, address, town, province " ;
		$query .= "FROM users where (" ;
		$counter = 0 ;
		$howMany = count($selection) ;
		if ($howMany >= 1) foreach ($selection as $index) {
		$counter++ ;
		$query .= "code = '$index'" ;
		if ($counter < $howMany) $query .= " OR " ;
		elseif ($counter == $howMany) $query .= " ) ORDER BY code" ;
		}
		// Keep for testing or debug
		//print "DAO query: $query<br/>" ;
		$result = mysql_query($query) or manageCustomerError() ;
		return $result ;
	}

/**********************************************************************************************/
/**********************			EXECUTE UPDATE METHODS		***********************************/
/**********************************************************************************************/

	/** Update the customer's data in the database.						*/
	function updateCustomer($code, $values) {

		global $result ;

		$query  = "UPDATE users SET code='$values[0]', name='$values[1]', surname='$values[2]', company='$values[3]', " ;
		$query .= "address='$values[4]', town='$values[5]', province='$values[6]', zip='$values[7]', " ;
		$query .= "country='$values[8]', telephone1='$values[9]', telephone2='$values[10]', mobile1='$values[11]', " ;
		$query .= "mobile2='$values[12]', fax='$values[13]', login='$values[14]', admin='$values[16]', notes='$values[17]'" ;
		if ($values[15] != "") {
			$value = md5($values[15]) ;
			// Keep for testing or debug: insert CLEAR password (not encrypted)
			// $value = $values[15] ;
			$query .= ", pwd = '$value'" ;
		}
		$query .= " WHERE code = " . $code;
		// Keep for testing or debug
		//print "DAO query: $query<br/>" ;
		$result = mysql_query($query) or manageCustomerError() ;
		return $result ;
	}


	/** Insert the customer's data in the database.						*/
	function insertCustomer($values) {

		global $result ;

		// Hard-coded management of some default data: country and password
		if ($values[8] == "") $values[8]  = "Italia" ;
		$values[15] = md5($values[15]) ;
		// Keep for testing or debug: insert CLEAR password (not encrypted)
		// $value = $values[15] ;
		
		// Building insert query
		$query  = "INSERT INTO users (code, name, surname, company, address, town, province, zip, country, " ;
		$query .= "telephone1, telephone2, mobile1, mobile2, fax, login, pwd, admin, notes) " ;
		$query .= "VALUES('$values[0]','$values[1]','$values[2]','$values[3]','$values[4]', '$values[5]', ";
		$query .= "'$values[6]','$values[7]','$values[8]','$values[9]','$values[10]', '$values[11]', '$values[12]', ";
		$query .= "'$values[13]','$values[14]','$values[15]','$values[16]','$values[17]')" ;
		// Keep for testing or debug
		//print "DAO query: $query<br/>" ;
		$result = mysql_query($query) or manageCustomerError() ;
		return $result ;
	}


	/** Insert the customer's data in the database.						*/
	function deleteCustomers($codes) {

		$index = 0 ;
		$number = count($codes) ;
		$query  = "DELETE FROM users WHERE (" ;
		foreach ($codes as $value) {
			$index++ ;
			$query .= "code = '$value' " ;
			if ($index < $number) $query .= "OR " ;
		}
		$query .= ")" ;
		// Keep for testing or debug
		//print "DAO query: $query<br>" ;
		$rows = mysql_query($query) or manageCustomerError() ;
		return $rows ;
	}

/**********************************************************************************************/
/***************************			UTILITIES			***********************************/
/**********************************************************************************************/

	/** Manages SQL errors.									*/
	function manageCustomerError() {
		
		echo "An error occured while managing the user access layer!" ;
		if  ( isset($customer_dao_debug) && $customer_dao_debug ) echo mysql_error() ;
		// Keep for testing or debug
		// echo mysql_error() ;
		// die("Query fallita") ;
	}

	/** Set the search parameters.									*/
	function searchCustomers() {

		$clause = "" ;
		// Each time we get parameters form the search page we set the new $searchQuery variable
		if ((isset($_POST['who'])) && (isset($_POST['where'])) ) {
			$who 	= $_POST['who'] ;
			$where 	= $_POST['where'] ;
			if ($who != "") 	$clause  = "(name like '%$who%' OR surname like '%$who%' OR company like '%$who%')" ;
			if ( ($who != "") && ($where != "") ) $clause .= " AND " ;
			if ($where != "") 	$clause .= "(town like '%$where%' OR province like '%$where%' OR country like '%$where%')" ;
			$_SESSION['searchQuery'] = $clause ;
			return $clause ;
		}
		// If we don't come from the search page, we check the "page" parameter
		if (isset($_GET['page'])) {
			if (isset($_SESSION['searchQuery'])) $clause = $_SESSION['searchQuery'] ;
		} else {
			$clause = "" ;
			unset($_SESSION['searchQuery']) ;
		}
		return $clause ;
	}

	/** Return an array containing the fields length.						*/
	function getCustomersColumns() {

		global $result ;

		$index = 0 ;
		$query = "SELECT * FROM users where code > 0" ;
		$result = mysql_query($query) or manageCustomerError() ;

		while ($index < mysql_num_fields($result)) {
			$meta = mysql_fetch_field($result);
			if (!$meta) { echo "Nessuna informazione disponibile<br>\n"; }
			$size[$index] = $meta->max_length ;
			$index++;
		}
		return $size ;
	}

	/** 
	* CONTROLLARE E CONFRONTARE CON ORIGINALE !?!
	* Used by the carriers page to obtain foreign key values.
	* Used also when sending an e-mail, to retrieve ???
	*/
	function getCustomersTable() {

		global $result ;

		$query = "SELECT * FROM users where code > 0" ;
		$result = mysql_query($query) or manageCustomerError() ;
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$code 				= $row["code"] ;
			$table[0][$code]	= $row["company"] ;
			$table[1][$code]	= $row["address"] ;
			$table[2][$code]	= $row["town"] ;
			$table[3][$code]	= $row["province"] ;
		}
		// Keep for testing or debug
		//print_r(array_values($table)) ;
		return $table ;
	}
?>