###########################################
###		Written by Stefano Adriani		###
###		Version			: 1.0			###
###		Last modified	: 30-09-2012	###
###########################################

CREATE TABLE users (
  code INT(8) NOT NULL PRIMARY KEY,
  name VARCHAR(20),
  surname VARCHAR(20),
  company VARCHAR(30) NOT NULL,
  address VARCHAR(30) NOT NULL,
  town VARCHAR(20) NOT NULL,
  province CHAR(3) NOT NULL,
  zip CHAR(5),
  country VARCHAR(20) DEFAULT 'Italia',
  telephone1 VARCHAR(20),
  telephone2 VARCHAR(20),
  mobile1 VARCHAR(20),
  mobile2 VARCHAR(20),
  fax VARCHAR(20),
  email VARCHAR(30),
  ipreg varchar(15) default '',
  datareg datetime default '0000-00-00 00:00:00',
  login VARCHAR(10) NOT NULL,
  pwd VARCHAR(60) NOT NULL,
  admin BOOLEAN DEFAULT '0',
  notes VARCHAR(120)
);

CREATE INDEX user_01 ON users(company) ;
CREATE INDEX user_02 ON users(login) ;

CREATE TABLE shipments (
  shipment_nr INT(8) NOT NULL PRIMARY KEY,
  document_nr INT(8) DEFAULT '0',  
  document_date DATE,				# As written on the DDT
  sender INT(8) NOT NULL DEFAULT '1' REFERENCES users(code) ON DELETE NO ACTION ON UPDATE CASCADE,
  recipient INT(8) NOT NULL DEFAULT '1' REFERENCES users(code) ON DELETE NO ACTION ON UPDATE CASCADE,
  address VARCHAR(20),				# By default is the recipient's one (but can be changed on the fly)
  town VARCHAR(20),					# By default is the recipient's one (but can be changed on the fly)
  province CHAR(3),					# By default is the recipient's one (but can be changed on the fly)
  order_nr INT(8),
  order_date DATE,
  boxes INT(3) DEFAULT '1',
  weight VARCHAR(12),
  store_date DATE,					# Date of arrival in the carrier's store
  planned_date DATE NOT NULL,		# Date planned for delivery
  delivery_date DATE,				# Actual date of delivery (when successfull)
  notes VARCHAR(120)
);

CREATE INDEX shipments_01 ON shipments(sender) ;
CREATE INDEX shipments_02 ON shipments(recipient) ;
  
# This does not work:
# ALTER TABLE shipments ADD CONSTRAINT check_01 FOREIGN KEY (sender) REFERENCES users(code) ON DELETE NO ACTION ON UPDATE CASCADE ;