<?php	  
	/** 
	* Testing features of the actual DAO approach (Object Oriented).
	* Current DAO implementation of the Phractice application is not a real DAO, since it's not OOP.
	*/

	// Defining base URL
	$root = "../../" ;
	
	include $root.'include/session_header.php' ; 		// Including pages that take care of the session and database  
	include $root.'include/database_header.php' ;		// Managing database connections  
	include $root.'include/display_header.php' ;		// Defining layout, images and loading the left menu    
            
	include $root.'classes/UserVO.php' ;				// Including the Value Object user class
	include $root.'classes/UserDAO.php' ;				// Including the actual user DAO (OOP)
?>

<script>
// Appending the users CSS at run-time
linkElement 		= document.createElement("link") ;
linkElement.rel 	= "stylesheet" ;
linkElement.href 	= "<?php echo $root ; ?>css/tutorial.css" ; 
document.head.appendChild(linkElement) ;
</script>

<div class="content_01">

<h3>Testing object oriented DAO approach</h3>

<p>
This page shows an example retrieving data using the DAO approach.
<br/><br/>
User's data are retrieved from the database using the <code>UserDAO</code> and <code>UserVO</code> objects,
defined in the <code>UserDAO.php</code> and <code>UserVO.php</code> pages (see the <code>classes</code> directory).
</p>

<br/>

<p><em>Sample code:</em></p>

<div class="dao-code">
<pre><code>
$dao 	= new UserDAO($connection) ;
$userVO = $dao->get(1) ;
$array 	= $userVO->getAllData() ;
echo '&lt;strong&gt;User data       :&lt;/strong&gt; '.count($array).'&lt;br/&gt;' ;
echo '&lt;strong&gt;User first name :&lt;/strong&gt; '.$userVO-&gt;getFirstName().'&lt;br/&gt;' ;
echo '&lt;strong&gt;User last name  :&lt;/strong&gt; '.$userVO-&gt;getLastName().'&lt;br/&gt;' ;
echo '&lt;strong&gt;All data:&lt;/strong&gt; ' ;
foreach ($array as $value) echo $value.' - ' ;
</code></pre>
</div>

<br/>

<p><em>Result:</em></p>

<div class="dao-code">
<?php
	// Creating the DAO instance using the $connection parameter (defined by the "database_header.php" page)
	$dao 	= new UserDAO($connection) ;
	$userVO = $dao->get(1) ;
	$array 	= $userVO->getAllData() ;
	echo '<strong>User data       :</strong> '.count($array).'<br/>' ;
	echo '<strong>User first name :</strong> '.$userVO->getFirstName().'<br/>' ;
	echo '<strong>User last name  :</strong> '.$userVO->getLastName().'<br/>' ;
	echo '<strong>All data:</strong> ' ;
	foreach ($array as $value) echo $value.' - ' ;
?> 
</div>

<br/><br/>

<nav class="dao-page">
<span><a href="02-test-insert.php" title="Testing the INSERT operation">Next</a></span>
</nav>

</div>

<br/><br/><br/>

<?php include $root.'include/display_footer.php' ;  ?>