<?php	
	$root = '../../' ;
	include_once 'test_header.php' ;	
?>

<h3>Checking the alternative PHP basic syntax</h3>

<?php 
	
	// Defining variables
	$a = 42 ;
	$b = 84 ;
	
	// 1. Use SINGLE QUOTE to avoid the parsing check!
	echo '<hr/>' ;
	echo '<p><strong>Testing single \'quote versus\' \'double quote\' parsing</strong></p>' ;
	echo "<code>&#36;a = 42 ;</code><br/>" ;
	echo "<code>\"Variable &#36;a is \".&#36;a</code>	=> "."Variable $a is ".$a."<br/>" ;
	echo "<code>'Variable &#36;a is '.&#36;a</code>		=> ".'Variable $a is '.$a.'<br/>' ;
	echo '<hr/>' ;
	
	// 2.1 Standard syntax for the IF..ELSE statement
	echo '<p><strong>Testing IF...ELSE standard syntax</strong></p>' ;
	if ($a == 42) { 
		echo '<code>if ($a == 42) { ... }</code> => OK<br/>' ;
	} elseif ($b == 84) {
		echo 'This sentence should not be shown (<code>elseif</code>)<br/>' ;
	} else {
		echo 'This sentence should not be shown (<code>else</code>)<br/>' ;
	} ;
	// Short version
	if ($a == 42) 	echo '<code>if ($a == 42) ... </code> (no curly braces) => OK<br/>' ; 	
	else 			echo '<code>if ($a == 42) ... </code> (no curly braces) => NOT OK<br/>' ; 
	// 2.2 Alternative syntax for the IF..ELSE statement
	echo '<p><strong>Testing IF...ELSE alternative syntax</strong></p>' ;
	if ($a == 42) :
		echo '<code>if ($a == 42) : ... endif ;</code> => OK<br/>' ;
	elseif ($b == 84) :
		echo 'This sentence should not be shown (<code>elseif</code>)<br/>' ;
	else : 
		echo 'This sentence should not be shown (<code>else</code>)<br/>' ;
	endif ;
	// Short version
	echo '<strong>Remark:</strong> short alternative syntax does not exist' ;
	echo '<hr/>' ;
	
	// 3.1 Standard syntax for the FOR statement
	echo '<p><strong>Testing FOR standard syntax</strong></p>' ;
	echo '<code>for ($n = 0 ; $n < 5 ; $n++) { echo "$n" ; }</code> => ' ;
	for ($n = 0 ; $n < 5 ; $n++) {
		echo "$n" ;
	}
	echo '<br/>' ;
	echo '<code>for ($n = 0 ; $n < 5 ; $n++) echo "$n" ; </code> (short syntax) => ' ;
	for ($n = 0 ; $n < 5 ; $n++) echo "$n" ;
	echo '<br/>' ;
	// 3.2 Alternative syntax for the FOR statement
	echo '<p><strong>Testing FOR alternative syntax</strong></p>' ;
	echo '<code>for ($n = 0 ; $n < 5 ; $n++) : echo "$n" ; endfor ;</code> => ' ;
	for ($n = 0 ; $n < 5 ; $n++) :
		echo "$n" ;
	endfor ;
	echo '<hr/>' ;

	// 5.1 Standard syntax for the WHILE statement
	$n = 0 ;
	echo '<p><strong>Testing WHILE standard syntax</strong></p>' ;
	echo '<code>while ($n++ < 5) { echo "$n" ; }</code> => ' ;
	while ($n++ < 5) { echo "$n" ; }
	$n = 0 ;
	echo '<br/>' ;
	echo '<code>while ($n++ < 5) echo "$n" ;</code>  (short syntax) => ' ;
	while ($n++ < 5) echo "$n" ;
	$n = 0 ;
	// 5.2 Alternative syntax for the WHILE statement
	echo '<p><strong>Testing WHILE alternative syntax</strong></p>' ;
	echo '<code>while ($n++ < 5) : 	echo "$n" ;	endwhile ;</code> => ' ;
	while ($n++ < 5) : 	echo "$n" ;	endwhile ;
	echo '<br/>' ;
	echo '<hr/>' ;
	
	// 6. Ternary operator
	echo '<p><strong>Testing ternary operator</strong></p>' ;
	echo '<code>echo ($a == 42) ? "OK" : "NOT OK" ;</code> => ' ;
	echo ($a == 42) ? "OK" : "NOT OK" ;
	echo '<hr/>' ;
	
	// 7. Other stuff
	echo '<strong>Remark</strong>: same syntac holds for <code>switch..endswitch</code> and <code>foreach..endforeach</code>' ;
?>

<br/><br/><br/>

<?php include 'test_footer.php' ?>