<?php	
	$root = '../../' ;
	include_once 'test_header.php' ;	
?>

<style>
span {
  display: block;
  font-size: 14px;
  line-height: 25px;
  margin-left: 50px; 
}
</style>

<h3>Showing some URL information</h3>

<p>
This page uses some function accessing the $_SERVER object to retrieve URL data.
See the PHP source page to investigate functions implementation.
</p>

<br/>

<?php
	// Return the base URL of the current page
	function getBaseURL() {
		if ( (isset($_SERVER["HTTPS"])) && ($_SERVER["HTTPS"] == "on") ) 	$base_url = "https://" ;
		else 																$base_url = 'http://' ;
		if ($_SERVER["SERVER_PORT"] != "80") {
			$base_url .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"] ;
		} else {
			$base_url .= $_SERVER["SERVER_NAME"] ;
		}
		return $base_url ;
	}

	// Return the complete URL of the current page
	function getCurrentPageURL() {
		return getBaseURL().$_SERVER["REQUEST_URI"];
	}

	function getPageName() {
		return substr($_SERVER["SCRIPT_NAME"], strrpos($_SERVER["SCRIPT_NAME"],"/") + 1) ;
	}
	
	function getInfo() {
		if (!isset($_SERVER['REQUEST_URI'])) 	$serverrequri = $_SERVER['PHP_SELF'] ; 
		else							 		$serverrequri = $_SERVER['REQUEST_URI'];
		$s = empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : ""; 
		$protocol = $_SERVER["SERVER_PROTOCOL"].$s; 
		$port = ($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"]); 
		return $protocol."://".$_SERVER['SERVER_NAME'].$port.$serverrequri; 
	}
	
	// Keep for testing or debug
	echo "<span><code>getBaseURL()</code> = ".getBaseURL()."</span>" ;
	echo "<span><code>getCurrentPageURL()</code> = ".getCurrentPageURL()."</span>" ;
	echo "<span><code>getPageName()</code> = ".getPageName()."</span>" ;
	echo "<span><code>getInfo()</code> = ".getInfo()."</span>" ;
	echo "<span><code>_SERVER['PHP_SELF']</code> = ".$_SERVER['PHP_SELF']."</span>" ;
	echo "<br/>" ;
?>

<p>Getting the same result using <code>window.location.href</code> JavaScript object:</p>

<script>document.write("<span><code>JavaScript window.location.href</code> = " + window.location.href + "</span>") ;</script>

<br/><br/>

<p style="margin-left:50px; font-size:12px;">
References:
<br/><br/>
<a href="http://it2.php.net/manual/en/funcref.php" title="PHP manual (online)">PHP function reference</a>
</p>

<br/>

<?php include 'test_footer.php' ?>