<?php
	$root = '../../' ;
	include_once 'test_header.php' ;
?>

<style>
p > a {
  display: block;
  margin-left: 50px;
}
</style>

<h3>Managing directories and files on the File System</h3>

<?php

	// Compression mode
	$compress_content = true ;

	// Current "work" directory
	echo '<code>getcwd()</code> = '.getcwd().'<br/><br/>' ;

	// Creating a new directory
	echo 'Trying to create directory <code>temp</code> => ' ;
	if ( file_exists('temp') ) {
		echo 'directory "temp" already exists!' ;
	} else {
		echo 'creating "temp" directory: ' ;
		echo ( mkdir('temp') ? 'OK' : 'NOT OK' ) ;	// Remark: no permissions on Windows!
	}
	echo '<br/><br/>' ;

	// Changing "work" directory
	echo 'Changing directory using command <code>chdir("temp")</code><br/><br/>' ;
	chdir('temp') ;
	echo '<code>getcwd()</code> = '.getcwd().'<br/>' ;
	echo '<br/><hr/>' ;

	// Writing a file
	echo '<strong>Testing read/write operations</strong><br/><br/>' ;
	echo 'Testing compressed write/read file : '.($compress_content?'Yes':'No')."<br/><br/>" ;
	echo 'Writing a new file in the <code>temp</code> directory => ' ;
	// Remark: the "w" flag works also on Windows!
	$new_file = fopen("content.txt", "w") ;				
	$message = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc ut elit id mi ultricies adipiscing. Nulla facilisi. Praesent pulvinar, sapien vel feugiat vestibulum, nulla dui pretium orci, non ultricies elit lacus quis ante. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam pretium ullamcorper urna quis iaculis. Etiam ac massa sed turpis tempor luctus. Curabitur sed nibh eu elit mollis congue. Praesent ipsum diam, consectetur vitae ornare a, aliquam a nunc. In id magna pellentesque tellus posuere adipiscing. Sed non mi metus, at lacinia augue. Sed magna nisi, ornare in mollis in, mollis sed nunc. Etiam at justo in leo congue mollis. Nullam in neque eget metus hendrerit scelerisque eu non enim. Ut malesuada lacus eu nulla bibendum id euismod urna sodales. " ;
	if ($compress_content) 	echo ( fwrite($new_file, gzcompress($message)) ? 'OK' : 'NOT OK' ) ;
	else					echo ( fwrite($new_file, $message) ? 'OK' : 'NOT OK' ) ;
	fclose($new_file) ;
	echo '<br/><br/>' ;

	// Reading a file
	echo 'Reading the file in the <code>temp</code> directory:<br/><br/>' ;
	// Remark: the "r" flag works also on Windows!
	$existing_file = fopen("content.txt", "r") ;		
	$size = filesize("content.txt") ;
	if ($compress_content) 	$content = gzuncompress(fread($existing_file, $size )) ;
	else 					$content = fread($existing_file, $size ) ;
	// Remark: write $size + 1 in the row above to reach the end of file!
	if (feof($existing_file)) echo 'Reached end of file!<br/>' ;
	echo 'FILE CONTENT => '.$content.'<br/>' ;
	fclose($existing_file) ;
	echo '<br/>' ;

	// Keep for testing or debug
	// testCompression() ;
	
/*
* Text compression: keep for testing or debug
*/
function testCompression() {

	$long_text =  "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc ut elit id mi ultricies adipiscing. Nulla facilisi. Praesent pulvinar, sapien vel feugiat vestibulum, nulla dui pretium orci, non ultricies elit lacus quis ante. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Aliquam pretium ullamcorper urna quis iaculis. Etiam ac massa sed turpis tempor luctus. Curabitur sed nibh eu elit mollis congue. Praesent ipsum diam, consectetur vitae ornare a, aliquam a nunc. In id magna pellentesque tellus posuere adipiscing. Sed non mi metus, at lacinia augue. Sed magna nisi, ornare in mollis in, mollis sed nunc. Etiam at justo in leo congue mollis. Nullam in neque eget metus hendrerit scelerisque eu non enim. Ut malesuada lacus eu nulla bibendum id euismod urna sodales. " ;
  	$compressed_text = gzcompress($long_text) ;
	echo "<hr/>" ;
	echo "ORIGINAL TEXT: ".$long_text."<br/>" ;
	echo "ORIGINAL SIZE: ". strlen($long_text)."<br/>";
	echo '<br/>' ;
	echo "COMPRESSED TEXT: ".$compressed_text."<br/>" ;
	echo "COMPRESSED SIZE: ". strlen($compressed_text)."<br/>";
	echo '<br/>' ;
	$uncompressed_text = gzuncompress($compressed_text) ; 
	echo "UNCOMPRESSED TEXT: ".$uncompressed_text."<br/>" ;
	echo "UNCOMPRESSED SIZE: ". strlen($uncompressed_text)."<br/>";
	echo "<hr/><br/>" ;
}
?>

<p style="MARGIN-LEFT:50px; FONT-SIZE: 12px;">References:<br/>
<a href="http://www.php.net/manual/it/book.dir.php">Directories</a>
<a href="http://php.net/manual/it/book.filesystem.php">File System</a>
</p>

<?php include 'test_footer.php' ?>