<?php	
	include_once 'test_header.php' ;	
?>

<h3>GD2 library configuration and basic functions</h3>

<?php 
	// Definition of resource files (images)
	$jpg_file = $root.'images/test/red.jpg' ;
	$png_file = $root.'images/test/red.png' ;
	$gif_file = $root.'images/test/watermark.gif' ;
	// Keep for testing or debug
	// var_dump($png_file) ;

	echo '<p><strong>Checking GD2 library configuration</strong></p>' ;
	// 1. Priting GD settings and parameters
	echo '<code>var_dump( gd_info() ) ;</code> => (see below)' ;
	var_dump( gd_info() ) ;
	echo '<hr/>' ;

	// 2. Creating PHP image objects
	echo '<p><strong>Creating PHP image objects</strong></p>' ;
	if ($png_image 	= imagecreatefrompng 	($png_file)	) 	echo '<code>$png_image = imagecreatefrompng($png_file)</code> => OK<br/>' ;
	if ($jpg_image 	= imagecreatefromjpeg	($jpg_file)	) 	echo '<code>$jpg_image = imagecreatefrompng($jpg_image)</code> => OK<br/>' ;
	if ($gif_image	= imagecreatefromgif 	($gif_file)	)	echo '<code>$gif_image = imagecreatefrompng($gif_image)</code> => OK<br/>' ;
	echo '<hr/>' ;
	
	// 3. Printing PHP image attributes
	echo '<p><strong>Printing PHP image attributes</strong></p>' ;
	echo '<code>print_r(getimagesize($png_file)) ;</code> => ' ;
	print_r(getimagesize ($png_file)) ;			echo '<br/>' ;
	echo '<code>print_r(getimagesize($jpg_file)) ;</code> => ' ;
	print_r(getimagesize ($jpg_file)) ;			echo '<br/>' ;
	echo '<code>print_r(getimagesize($gif_file)) ;</code> => ' ;
	print_r(getimagesize ($gif_file)) ;			echo '<br/>' ;
	echo '<hr/>' ;
	
	// 4. Using list to get 2 array values using a "bundle oriented" syntax
	echo '<p><strong>Getting image attributes using the <code>list</code> keyword</strong></p>' ;
	echo '<code>list($width, $height) = getimagesize($png_file) ; </code><br/>' ;
	echo '<code>echo $width.\'x\'.$height</code> => ' ;
	list($width, $height) = getimagesize ($png_file) ;
	echo $width.'x'.$height.'<br/>' ;
?>

<?php include 'test_footer.php' ?>