<?php	
	$root = "../../ " ;
	// Including libraries
	include_once 	'test_header.php' ;	
	include 		'simpleObject.php' ;
	// Personal note:
	// See my article about PHP pointers (Aziende Italia - June 2012)
?>

<h3>Variables, objects and pointers </h3>

<br/>

<?php 
	// Function used to test behaviour of local variable defined as "&$a"
	function simpleTest(&$a) {
		echo 'Local variable => '.++$a.'<br/>' ;
	}
	// Function used to test behaviour of local variable defined as "&$a"
	function complexTest(&$a) {
		$my_a =& $a ;
		echo 'Local variable => '.++$my_a.'<br/>' ;
	}
	// Function used to test behaviour of local variable defined as "&a" (normal usage)
	function testObject($o) {
		$my_o = $o ;
		$my_o->increment() ;
		echo 'Local object => '.$my_o->getId().'<br/>' ;
	}
	
	// 1. Basic test: showing 
	echo 'Introducing the <strong>pointer</strong> concept: variables assigned using the "<code>&amp;&#36;</code>" operator ' ;
	echo 'are just another identifier of the same variable (i.e. they are a <em>pointer</em> variables).<br/>' ;
	echo 'This syntax allows to manage primitive values as if they were objects.<br/><br/>' ;
	echo '<strong>Remark:</strong> following syntax are equivalent: ' ;
	echo '<code>&#36;a = &amp;&#36;b</code>, <code>&#36;a =&amp; &#36;b</code>, <code>&#36;a = &amp; &#36;b</code>' ;
	echo '<br/><br/>' ;
	echo '<code>&#36;a = 10 ; &#36;b = 10 ;</code><br/>' ;
	echo '<code>$c = $a ; $d = &$b ;</code><br/>' ;
	echo '<code>$c++ ; $d++ ;</code><br/>' ;
	echo '<br/>' ;
	echo 'Result:<br/><br/>' ;
	$a = 10 ;		$b = 10 ;
	$c = $a ;		$d = &$b ;
	$c++ ;			$d++ ;
	echo "<code>&#36;a = $a &#36;b = $b</code><br/>" ;
	echo "<code>&#36;c = $c &#36;d = $d</code><br/>" ;
	echo '<br/>' ;
	echo '<hr/>' ;
  
	// 2. Testing primitives
	echo '<strong>Testing primitives calls</strong>' ;
?>
<pre><code>
$my_var = 10 ;
simpleTest($my_var) ;
function simpleTest(&$a) {
  echo 'Local variable => '.++$a.'&lt;br/&gt;' ;
}
echo 'Global value => '.$my_var.'&lt;br/&gt;' ;
</code></pre>
<?php	
	// 2.1 Result
	echo 'Global variable changes when local variable changes:<br/><br/>' ;
	$my_var = 10 ;
	simpleTest($my_var) ;
	echo 'Global value => '.$my_var.'<br/>' ;
	echo '<br/><hr/>' ;
	
	// 3. Testing primitives
	echo '<strong>Testing primitives calls (double pointer definition)</strong>' ;
?>
<pre><code>
$my_var = 10 ;
complexTest($my_var) ;
function complexTest(&$a) {
  $my_a =& $a ;
  echo 'Local variable => '.++$my_a.'&lt;br/&gt;' ;
}
echo 'Global value => '.$my_var.'&lt;br/&gt;' ;
</code></pre>
<?php	
	// 3.1 Result
	echo 'Same result as previous test:<br/><br/>' ;
	$my_var = 10 ;
	complexTest($my_var) ;
	echo 'Global value => '.$my_var.'<br/>' ;
	echo '<br/><hr/>' ;
	
	// 4. Testing object
	echo '<strong>Testing objects pointer</strong>' ;
	echo '<br/><br/>' ;
	echo 'This test create an instance of the <code>simpleObject</code> object, which is just a simple wrapper:' ;
?>
<pre><code>
class simpleObject {
  private $id ;
  function __construct($id)     { $this->id = $id ;   }
  public function increment()   { $this->id++ ;       }
  public function getId()       { return $this->id ;  }
}
</code></pre>
<?php	
	// 4.1 Test documentation
	echo 'Then we run following code:' ;
?>
<pre><code>
$obj = new simpleObject(42) ;
testObject($obj) ;
echo 'Original object => '.$obj->getId().'&lt;br/&gt;' ;

function testObject($o) {
  $my_o = $o ;
  $my_o->increment() ;
  echo 'Local object => '.$my_o->getId().'&lt;br/&gt;' ;
}
</code></pre>
<?php	
	// 4.2 Test result:
	$obj = new simpleObject(42) ;
	testObject($obj) ;
	echo 'Original object => '.$obj->getId().'<br/>' ;
	echo '<br/>' ;
	echo 'Result: object are always managed as pointers! (standard OOP paradigm)' ;
?>

<?php include 'test_footer.php' ?>