<?php	
	include_once 'test_header.php' ;	
	include_once 'test_class.php' ;
	// Defining formatting helper variable
	$holds = ' <span>returns</span> ' ;
?>

<style>
span {	
  FONT-STYLE: italic;
  FONT-FAMILY: Verdana;
}
</style>

<h3>Static fields</h3>
<p>
Showing that <code>static</code> class fields work as expected within the <b>same</b> PHP page.<br/>
For a complete understanding of this example see the PHP source of the "<code>test_class.php</code>" page
(used to define the "<code>TestObject</code>" class).
</p>

<p><strong>Testing that static fields hold the same value within the same page</strong> (for different instances)</p>

<code>
<?php 
	$test_a = new TestObject('A') ;
	$test_b = new TestObject('B') ;
	echo '$test_a = new TestObject(\'A\') ;<br/>' ;
	echo '$test_b = new TestObject(\'B\') ;<br/>' ;
	echo '$test_a->getStaticValue();'.$holds.$test_a->getStaticValue().'<br/>' ;
	echo '$test_b->getStaticValue();'.$holds.$test_b->getStaticValue().'<br/>' ;
	echo '$test_a::$public_static = 17 ;<br/>' ;
	$test_a::$public_static = 17 ;
	echo '$test_a->getStaticValue() ;'.$holds.$test_a->getStaticValue().'<br/>' ;
	echo '$test_b->getStaticValue() ;'.$holds.$test_b->getStaticValue().'<br/>' ;
	echo '<br/>' ;
?>
</code>

<hr/>

<p><strong>Testing direct access to a public class field</strong> (i.e. avoiding setter/getter methods)</p>

<code>
<?php
	echo '$test_a::$public_static'.$holds.$test_a::$public_static.'<br/>' ;
	echo '$test_b::$public_static'.$holds.$test_b::$public_static.'<br/>' ;
	echo 'TestObject::$public_static'.$holds.TestObject::$public_static.'<br/>' ;
?>
</code>

<hr/>

<p><strong>Testing access to an ordinary field</strong> (not static)</p>

<code>
<?php
	echo '$test_a->my_field'.$holds.$test_a->my_field.'<br/>' ;
	echo '$test_b->my_field'.$holds.$test_b->my_field.'<br/>' ;
	
	// Keep for testing or debug: these DOES NOT work
	// Wrong syntax: when accessing a static field it's mandatory to write "$test_a::$public_static" (see above)
	// echo $test_a->public_static.'<br/>' ;
	// echo $test_a->$public_static.'<br/>' ;
?>
</code>

<?php	include_once 'test_footer.php' ;	?>