<?php	
	include_once 'test_header.php' ;	
	include_once 'test_class.php' ;
	// Defining formatting helper variable
	$holds = ' <span>returns</span> ' ;
?>

<style>
span {	
  FONT-STYLE: italic;
  FONT-FAMILY: Verdana;
}
</style>


<h3>Static fields</h3>
<p>
Showing that <code>static</code> class fields are not shared among different PHP pages.<br/>
For a complete understanding of this example see the PHP source of the "<code>test_class.php</code>" page
(used to define the "<code>TestObject</code>" class).
</p>

<p><strong>Checking that we are not using the same class of the "<code>02-static_field_1.php</code>" page</strong></p>

<code>
<?php 	
	echo 'testObject::$public_static;'.$holds.testObject::$public_static.'<br/>' ;	
?>
</code>

<p>In the "<code>02-static_field_1.php</code>" page</strong> we set the "<code>$public_static</code>" field to 17,
but now the value is 5 (the default value, as defined in the class declaration)<br/>
 => this proves that here we are using another static instance of the "<code>TestObject</code>" class!
</p>

<hr/>

<p><strong>Static local variables (1)</strong></p>
<p>Testing behavior of <code>static</code> keyword used as local variable of the <code>staticTest</code> method:</p>
<p>Implementation of the <code>staticTest</code> method:</p>
<pre><code>
public static function staticTest() {		
  static $inner = 0 ;
  $inner++ ;
  return $inner ;
}
</code></pre>
<p>Result:</p>
<code>
<?php 	
	echo 'testObject::staticTest();'.$holds.testObject::staticTest().'<br/>' ;	
	echo 'testObject::staticTest();'.$holds.testObject::staticTest().'<br/>' ;	
	echo 'testObject::staticTest();'.$holds.testObject::staticTest().'<br/>' ;	
	echo '<br/><hr/>' ;
?>
</code>

<p><strong>Static local variables (2)</strong></p>
<p>Testing behavior of <code>static</code> keyword used as local variable of the <code>nonStaticTest</code> method:</p>
<p>Implementation of the <code>nonStaticTest</code> method:</p>
<pre><code>
public static function nonStaticTest() {		
  $inner = 0 ;
  $inner++ ;
  return $inner ;
}
</code></pre>
<p>Result:</p>
<code>
<?php 	
	echo 'testObject::nonStaticTest();'.$holds.testObject::nonStaticTest().'<br/>' ;	
	echo 'testObject::nonStaticTest();'.$holds.testObject::nonStaticTest().'<br/>' ;	
	echo 'testObject::nonStaticTest();'.$holds.testObject::nonStaticTest().'<br/>' ;	
?>
</code>

<?php	include_once 'test_footer.php' ;	?>