<?php	
	include_once 'test_header.php' ;	
	include_once 'test_class.php' ;
	// Defining formatting helper variable
	$holds = ' <span>returns</span> ' ;
?>

<style>
span {	
  font-style: italic;
  font-family: verdana;
}
</style>

<h3>Sharing objects using the HTTP session (part 1)</h3>
<p>
Accessing a simple class field via direct access or via getter method: we get same result.<br/>
For a complete understanding of this example see the PHP source of the "<code>test_class.php</code>" page
(used to define the "<code>TestObject</code>" class).
</p>

<code>
<?php 	
	$obj = new TestObject(99) ;
	echo '$obj = new TestObject(99);<br/>' ;
	echo '$obj->my_field;'.$holds.$obj->my_field.'<br/>' ;
	echo '$obj->getFieldValue() ;'.$holds.$obj->getFieldValue().'<br/>' ;
?>
</code>

<br/><hr/>

<p>
Changing the class field value using a setter method and reading the new value.<br/>
As above: getter method and direct public access return the same result.
</p>

<code>
<?php 	
	$the_value = 70 ;
	$obj->setFieldValue($the_value) ;
	echo '$obj->setFieldValue('.$the_value.') ;<br/>' ;
	echo '$obj->my_field;'.$holds.$obj->my_field.'<br/>' ;
	echo '$obj->getFieldValue() ;'.$holds.$obj->getFieldValue().'<br/>' ;
?>
</code>

<br/><hr/>

<p>
Assigning a value to the static field and serializing it in the HTTP session.<br/>
The static field is defined in the "<code>test_class.php</code>" page in this way:
</p>
<pre><code>
public static $public_static = 5 ;
</code></pre>

<p>
As above, the getter method and direct public access will return the same result.<br/>
Notice that now we MUST use a different syntax when accessing the field (i.e. <code>TestObject::$public_static</code>).
</p>

<code>
<?php
	TestObject::$public_static = 42 ;
	echo 'TestObject::$public_static = 42 ;<br/>' ;
	echo '$obj->getStaticValue();'.$holds.$obj->getStaticValue().'<br/>' ;
	echo 'TestObject::$public_static;'.$holds.TestObject::$public_static.'<br/><br/>' ;
	echo '$_SESSION[\'OBJ_REF\'] = serialize($obj) ;<br/>' ;
	$_SESSION['OBJ_REF'] = serialize($obj) ;
?>
</code>

<p>
<strong>Remark:</strong> the last command <strong>serializes</strong> the object and stores it in the HTTP session.<br/>
This will allow us to retrieve the object from the session in another page (see "<code>05-sharing_objects_2.php</code>").<br/>
We can check this by reading the <code>$public_static</code> field to see if it holds the value set in this page (i.e. "42").
</p>

<?php	include_once 'test_footer.php' ;	?>