<?php	
	include_once 'test_header.php' ;	
	include_once 'test_class.php' ;
	// Defining formatting helper variable
	$holds = ' <span>returns</span> ' ;
?>

<style>
span {	
  FONT-SIZE: 12;
  FONT-STYLE: italic;
  FONT-FAMILY: Verdana;
}
</style>

<h3>Sharing objects using the HTTP session (part 2)</h3>
<p>
Checking that here we are using the same object of the "<code>04-sharing_objects_1.php</code>" page.<br/>
Notice that the object is the same, but the class is a new one: see also the "<code>06-sharing_objects_3.php</code>" page!	
</p>

<pre><code>
<?php 	
   echo 'if (isset($_SESSION[\'OBJ_REF\'])) {<br/>' ;
	if (isset($_SESSION['OBJ_REF'])) {
		$my_obj = unserialize($_SESSION['OBJ_REF']) ;
		echo '  $my_obj = unserialize($_SESSION[\'OBJ_REF\']) ;<br/>' ;
		echo '  $my_obj->my_field ;'.$holds.$my_obj->my_field.'<br/>' ;
		echo '  $my_obj::$public_static ;'.$holds.$my_obj::$public_static.'<br/>' ;
		echo '  TestObject::$public_static ;'.$holds.TestObject::$public_static.'<br/>' ;
	} else {
		echo '  Object not found in the HTTP session!<br/>' ;
	}
	echo '}<br/>' ;
?>
</code></pre>

<p><strong>Result:</strong></p>
<p>
The <code>$my_obj</code> object is the same of previous page (i.e. "<code>04-sharing_objects_1.php</code>"), since we found the same value stored<br/>
before in the instance field <code>my_field</code> (i.e. "70"), but the class loaded here is different!
Now the class static field <code>public_static</code><br/>
has been reset to the default value  (i.e. "5") instead of the value set in the previous page (i.e. "42").
<br/><br/>
This explains that in PHP is pointless storing static class field aiming to get an unique value within the application context,
since every page loads his own version of the class.<br/>
To store an unique value we must use a singleton approach, i.e. we must
define the object as an ordinary class field (not static) within a wrapper object,<br/>
then we must share such object by serializing it and storing it in the HTTP session.
</p>

<?php	include_once 'test_footer.php' ;	?>