<?php
	/** 
	* This page shows the user personal sheet for a single user/administrator.
	* Two pages can be targeted from here:
	*    - users_update.php: if the user confirms the values written in the INPUT fields.
	*    - users_confirm.php: if the user chooses to delete the current record.
	*
	* In both cases data are passed as INPUT fields of the HTML form, then the POST method is involved, 
	* but the ACTION value of the HTML form is changed on the fly to redirect the page (JavaScript).
	*/

	include '../include/session_header.php';	 	// Including pages that take care of the session and paging
	include '../include/database_header.php' ;		// Managing database connections
	include '../include/users_DAO.php';				// Including pages managing the users table (DAO layer)
	include '../include/display_header.php' ;		// Defining layout, images and loading the left menu  

	// 1. Recognizing the action selected by the user.
	$rows 		= 18 ;
	$columns 	= 2 ;
	$span 		= $columns + 1 ;
	$code 		= $_GET['code'] ;
	if ( isset($_SESSION['USER_VIEW']) ) 	$mode = $_SESSION['USER_VIEW'] ;
	else									$mode = 1 ;
	if ($code > 0) 	$operation = "DATI" ; 
	else 			$operation = "INSERIMENTO" ;

	// 2. Customizing table layout
	include '../include/users_labels.php' ;
	print "<p class='td_customers_title'>$operation $labelTitle</p>" ;
?>

<script language="JavaScript">
// Validate function
function postForm(number) {
	if (number == 1) {
		num = document.update.field0 ;
		azi = document.update.field3 ;
		ind = document.update.field4 ;
		cit = document.update.field5 ;
		pro = document.update.field6 ;
		log = document.update.field14 ;
		pwd = document.update.field15 ;
		if (num.value == "") { alert("E' necessario assegnare un numero di codice!") ; 			num.focus() ; return false ; }
		if (num.value <= 0)  { alert("Il codice del cliente deve essere un numero positivo!") ; num.focus() ; return false ; }
		if (azi.value == "") { alert("Specificare il nome dell'azienda!") ; 					azi.focus() ; return false ; }
		if (ind.value == "") { alert("Specificare l'indirizzo per le spedizioni!") ; 			ind.focus() ; return false ; }
		if (cit.value == "") { alert("Specificare la citt!") ; 								cit.focus() ; return false ; }
		if (pro.value == "") { alert("Specificare la sigla della provincia!") ; 				pro.focus() ; return false ; }
		if (log.value == "") { alert("Specificare il login dell'utente") ; 						log.focus() ; return false ; }
<?php if ($code == 0) { 	?>
		// Remark: we need to check password only when inserting a new customer, because we leave the field empty
		// when the administrator is editing the user data.
		if (pwd.value == "") { alert("Specificare la password dell'utente") ; 					pwd.focus() ; return false ; }
<?php } 					?>		
		document.update.quest.value = number ; 
		document.update.action = "users_update.php" ;
		// Not needed: we are using "submit" buttons
		//document.update.submit() ;
	}
	if (number == 2) { 
		document.update.quest.value = number ; 
		document.update.action = "users_confirm.php" ;
		// Not needed: we are using "submit" buttons
		//document.update.submit() ;
	}
	//console.log("Posted to " + document.update.action) ;
}
// Help function
function help() {
	var msg  = "La password non puo' essere visualizzata per motivi di sicurezza.\n" ;
	msg 	+= "Per confermare la password corrente, lasciare vuoto questo campo.\n" ;
	msg 	+= "Altrimenti, se si desidera inserire una nuova password, digitarla in questo campo." ;
	document.update.field15.focus() ;
	alert(msg) ;
}
// Appending the users CSS at run-time
linkElement 		= document.createElement("link") ;
linkElement.rel 	= "stylesheet" ;
linkElement.href 	= "../css/users.css" ; 
document.head.appendChild(linkElement) ;
// jQuery section
$(document).ready( function() {
	// Filling form with default values (keep for testing or debug)
	$('.icon').click( function() {
		$('input[name*="field"]').each( function() {
			var n = this.name.substr(5,7) ;
			if (this.value.length == 0) this.value = 'Foo' + n;
		}) ;
	}) ;
	// If necessary emptying password field (only when INSERTING a new user)
<?php if ($code == 0) { 	?>
	$('input[name=field15]').val('') ;
	// $('input[name=field15]').css('background-color', 'red') ;
<?php } 					?>
}) ; // End of jQuery "$(document).ready()"
</script>
  
<table id="customer_data">
<tr>
  <td class="td_customers_title" colspan="<?php print "$span" ?>">
  SCHEDA <?php print $labelCaption ?>
  <img class="icon" src="../images/icons/fill_default.gif" title="Fill with default data" alt="Default data"/>
  </td>
</tr>
  
<form name="update" method="post">

<?php
	// Case 1: printing users data (EDIT)
	if ($code > 0) {
		$lines = 0 ;
		$recordSet = getCustomer($code) ;
		while ($row = mysql_fetch_array($recordSet, MYSQL_BOTH)) {
			$lines += 1 ;
			for ($index = 0; $index < $rows ; $index++) {
				print "<tr>\n" ;
				print "\t<td class='td_customers_label'>&nbsp;$customersLongName[$index]" ;
				// Keep for testing or debug
				// print "\t<td class='td_customers_label'>$index-$customersLongName[$index]" ;
				if ($customersLongName[$index] == "Password") 
					print "&nbsp;<a href='#' tabIndex='-1' onClick='help()'>(<small>Info</small>)</a>" ;
				print "</td>\n" ;
				print "\t<td class='td_customers_data'>" ;
				if ($customersLongName[$index] == "Password") {
					print "<input type='textbox' class='td_customers_input' name='field$index' value=''/>" ;
					// Showing password is useless, since is stored using MD5 encryption
					// print "<input type='textbox' class='td_customers_input' name='field$index' value='$row[$index]'/>" ;
					
				} else if ($customersLongName[$index] == "Amministratore") {
					$flag = (($row[$index] == 1) ? "checked" : "") ;
					print "<input type='checkbox' class='td_customers_checkbox' name='field$index' $flag/>" ;
				}
				else print "<input type='textbox' class='td_customers_input' name='field$index' value='$row[$index]'/>" ;
				print "</td>\n" ;
				print "</tr>\n";
			} // End of for
		} // End of while
	} // End of "if ($code > 0) ..."

	// Case 2: inserting new user (INSERT)
	else {
		$nextCode = getMaxCustomer() + 1 ;  
		$admin = ($mode == 0)?"checked":"" ;
		for ($index = 0; $index < $rows ; $index++) {
			print "<tr>\n" ;
			print "\t<td class='td_customers_label'>&nbsp;$customersLongName[$index]</td>" ;
			// Keep for testing or debug
			// print "\t<td class='td_customers_label'>$index-$customersLongName[$index]</td>" ;
			print "\t<td class='td_customers_data'>" ;
			if ($index == 0) print "<input type='textbox' class='td_customers_input' name='field$index' value='$nextCode'/>" ;      
			elseif ($customersLongName[$index] == "Password") 		print "<input type='password' class='td_customers_input' name='field$index'/>" ;
			elseif ($customersLongName[$index] == "Amministratore") print "<input type='checkbox' type='td_customers_checkbox' name='field$index' $admin/>" ;
			else print "<input type='textbox' class='td_customers_input' name='field$index'/>" ;
			print "</td>\n" ;
			print "</tr>\n" ;
		}
	}
	
	// 3. Releasing resources
	releaseAll() ;
?>

</table>

<br>

<!-- If the target is "user_update", data are passed within the form -->
<input type="hidden" name="quest" value="0">
<input type="hidden" name="code" value="<?php print "$code" ?>">
<!-- If the target is "users_confirm", different data are passed within the form -->
<input type='hidden' name='record<?php print $code ; ?>' value='on'>

<nav class="userdata_nav">
<table class="centered"> 
  <tr>
    <td class="td_customers_action">
      <a href="users_list.php?page=1"><input type="button" value="Annulla l'operazione" title="Annulla l'operazione"></a>
    </td>
    <td class="td_customers_action">
	  <input type="submit" onclick="return postForm(1);" value="Conferma le modifiche" title="Conferma le modifiche">
    </td>
    <td class="td_customers_action">
<?php 
	// Editing customer data
	if ($code > 0) {
		print "\t<input type='submit' onclick='postForm(2);' value='Cancella $label_01' title='Cancella $label_01'>\n" ;
		print "</td>" ;
		print "<td class='td_customers_action'>" ;      
		print "\t<a href='../carriers/carriers_list.php?customer=$code'>\n" ;
		print "\t<input type='button' value='Spedizioni $label_01' title='Consulta spedizioni'>\n" ;
		print "\t</a>\n" ;      
	} 
?>
  </td>
  </tr>
</table>
</nav>

</form>

<?php include '../include/display_footer.php' ?>