<?php	  
	/** 
	* This page lists all the existing USERS or ADMINISTRATORS (and allows multiple selection).
	* Three pages can be targeted from here:
	* - users_data.php			: if the user clicks on one table's row or select "new record" (single selection)
	* - users_confirm.php		: if the user chooses the "modify" or "delete" option (multiple selection)
	* - users_search.php		: open the research page (no data are passed to the search page)
	* In the first case data are passed through the HTTP request (GET method), in the second case data are passed
	* using the POST method (as INPUT fields of the HTML form).
	*/

	// 1. Including resources
	include '../include/session_header.php' ; 		// Including pages that take care of the session and paging  
	include '../include/database_header.php' ;		// Managing database connections  
	include '../include/users_DAO.php' ;			// Including pages managing the users table (DAO layer)  
	include '../include/display_header.php' ;		// Top presentation header: defining layout, images and loading the left menu  
	// See also "customers_labels.php", include below
	
	// 2. Setting page parameters
	$customersWidth 	= getCustomersColumns() ;
	$customersName		= getCustomersHeaders() ;

	// 3. Recognizing the view mode selected by the user
	// DEPRECATED: in previous versions the "mode" parameter was passed using plain GET or POST (not Ajax)
	// if 		(isset( $_GET['mode']  	))		$mode = $_GET['mode'] ; 
	// elseif 	(isset( $_POST['mode']	))		$mode = $_POST['mode'] ;
	// CURRENT MODE: retrieving the view mode from the HTTP session (set using an Ajax call)
	if ( isset($_SESSION['USER_VIEW']) ) 	$mode = $_SESSION['USER_VIEW'] ;
	// If we arrived from the search page, we retrieve the search parameters (using the POST method):
	// we get these data from the "searchCustomers()" function (see the "users_DAO.php" page)
	// If we don't arrived here from the search page, the $searchQuery will be an empty string.
	$searchQuery = searchCustomers() ;
	 
	// 4. Customizing table layout
	$delta 		= 10 ;
	$columns 	= 8 ;
	include '../include/users_labels.php' ;

	// 5. Formatting page for navigation: see "session_header.php"
	formatPage($mode, $searchQuery, "users") ;
	$nextPage 	= (($pageNumber + 1) < $lastPage) ? ($pageNumber + 1) : $lastPage ;
	$previousPage = (($pageNumber - 1) > 0) ? ($pageNumber - 1) : 1 ;
	$recordSet 	= getCustomersList($mode, $searchQuery, $maxLimit, $offset) ;
	$rows 		= mysql_num_rows($recordSet) ;
?>

<script language="JavaScript">
// User actions (page bottom)
function goToPage(number) {
	if (number == 1) { window.location.href = "users_data.php?code=0" ; 	}
	if (number == 2) { window.location.href = "users_search.php" ; 		}
}
// User actions (page bottom)
function postForm(number) {
	if (number == 1) { document.selection.quest.value = number ; }
	if (number == 2) { document.selection.quest.value = number ; }
	document.selection.submit() ;
	//console.log("Quest value = " + document.selection.quest.value) ;
}
// Appending the users CSS at run-time
linkElement 		= document.createElement("link") ;
linkElement.rel 	= "stylesheet" ;
linkElement.href 	= "../css/users.css" ; 
document.head.appendChild(linkElement) ;
// jQuery: adding zebra crossing
$(document).ready( function() {
	$('#customer_table tr:odd').addClass('td_odd') ;
	$('#customer_table tr:even').addClass('td_even') ;
}) ;
// jQuery: adding zebra crossing
function toggleChecked(status) {
	$('.checkbox').each( function() {
		$(this).attr('checked', status) ;
	}) ;
	if (status) $('.checkall_label').text('Deseleziona tutti') ;
	else $('.checkall_label').text('Seleziona tutti') ;
} ;
</script>

<?php
	// 6. If necessary adding the CSS file for ADMINISTRATORS appereance
	if ($mode == 0) {
		echo "<!-- Added at runtime -->\n" ;
		echo "<script language='JavaScript'>\n" ;
		echo "other_style		= document.createElement('link');\n" ;
		echo "other_style.rel	= 'stylesheet';\n" ;
		echo "other_style.href 	= '../css/admin.css';\n" ;
		echo "document.head.appendChild(other_style);\n" ;
		echo "</script>\n" ;
	}
	
	// 7. Printing table (if data are available)
	if ($rows > 0) {
?>  

  <form name="selection" action="users_confirm.php" method="post">

  <div id="customer_table">
  <table border="0px">
    <tr>
    <td class='checkall'><input type="checkbox" onclick="toggleChecked(this.checked);"></td>
    <td class="checkall_label" colspan="3">Seleziona tutti</td>
    <td class="table_caption" colspan="<?php print ($columns - 4) ?>">ELENCO <?php print $labelTitle ; ?></td>
	</tr><tr>
   
<?php  
	// PRINTING USERS TABLE
    // 1. Printing table headers, assigning "td width" considering field's length from the database
    print "\t<td class='td_customers_header'>Sel.</td>\n" ;
    foreach ($customersName as $index => $caption) {
        $width = $delta*($customersWidth[$index]) ;
        print "\t<td width='$width px' class='td_customers_header'>$caption</td>\n" ;
		// Keep for testing or debug
        //print "\t<td width='$width px' class='td_customers_header'>$index-$customersWidth[$index]</td>\n" ;
    }
    print "</tr>" ;
    // 2. Printing table data
    $line = 0 ;
    while ($row = mysql_fetch_array($recordSet, MYSQL_ASSOC)) {
		$index = 0 ;
		$line += 1 ;
		// 2.1 Printing first special column (checkbox)
		// Remark: the setting MYSQL_ASSOC is case-sensitive (with respect of the SQL statement)
		$code = $row["code"] ;
		print "<tr class='customer_row'>\n" ;
		print "\t<td><input type='checkbox' class='checkbox' name='record$code'></td>\n" ;
		// 2.2 Printing all other columns (actual values from database)
		foreach ($row as $value) {
			$width = $delta*($customersWidth[$index]) ;
			if (isset($customersName[$index])) {
				print "\t<td width='$width px'>" ;
				print "<a href='users_data.php?code=$code'>$value" ;
				print "</a></td>" ;
				// Keep for testing or debug
				//print "<td>$index - $value</td>" ;
			}
			$index += 1 ;
		}
		print "</tr>\n";
	} // End of "while"
	
?>
  </table>
  </div> <!-- End of users table -->
  
<div class="table_nav">
<span>Utenti <?php print $rows; ?> di <?php print $records; ?></span>
<span class="nav_footer">Pagina <?php print $pageNumber; ?> di <?php print $lastPage; ?></span>
<nav class="page_nav">
<?php 
	// Page to be shown before and after current page
	$range = 4 ;
	if ($pageNumber > 1) print "<a class='nav_link_prev' href='users_list.php?page=$previousPage'>Indietro</a>" ;
	$start_page	= ($pageNumber > $range ) ? ($pageNumber - $range) : 1 ;
	$end_page	= (($pageNumber + $range) < $lastPage) ? ($pageNumber + $range) : $lastPage ;
	print "<div class='nav_links'>" ;
	for ($i = $start_page ; $i <= $end_page ; $i++) {
		$style = "" ;
		if ($i == $pageNumber) $style = "class='current_page'" ;
		print "<a $style href='users_list.php?page=$i'>$i</a>\n" ;
	} 
	print "</div>" ;
	if ($pageNumber < $lastPage) print "<a class='nav_link_next' href='users_list.php?page=$nextPage'>Avanti</a>" ;
?>
</nav>

</div>

<?php

  // End of "if ($rows > 0)"
  } else {
    print "<p class='td_customers_title'>RISULTATI DELLA RICERCA</p>\n" ;
    print "<br/>\n" ;
    print "<p class='td_customers_title'>Nessun cliente soddisfa i parametri di ricerca</p>\n" ;
    print "<br/><br/>\n" ;
  }
  
  // 5. Releasing resources (see the "database_header.php" page)
  releaseAll() ;
?>

<br/>

<!-- If the target page is "users_confirm.php", data are passed within the form, usin the POST method -->
<input type="hidden" name="quest" value="0">

<nav class="user_nav">
<table>
  <tr>
	<td class="td_customers_action">
	<input type="button" onclick="goToPage(1)" value="Inserisci <?php print $label_01 ; ?>" title="Inserisci nuovo <?php print $label_01 ; ?>">
	</td>
	<td class="td_customers_action">
	<input type="button" onclick="postForm(1)" value="Modifica <?php print $label_01 ; ?>" title="Modifica i dati di un <?php print $label_01 ; ?>">
	</td>
	<td class="td_customers_action">
	<input type="button" onclick="postForm(2)" value="Cancella <?php print $label_01 ; ?>" title="Cancella un <?php print $label_01 ; ?>">
	</td>
	<td class="td_customers_action">
	<input type="button" onclick="goToPage(2)" value="Ricerca <?php print $label_01 ; ?>" title="Cerca un <?php print $label_01 ; ?>">
	</td>
  </tr>
</table>
</nav>

</form>

<?php
if ($searchQuery != "") {
	echo "<p class='another_search centered' style='WIDTH:200px;'>" ;
	echo "<a href='users_search.php'>Prova con un'altra ricerca</a>" ;
	echo "</p>" ;
}
?>

<?php include '../include/display_footer.php'; ?>