<?php	  
	/** 
	* This page receives the action from the "customers_data" page.
	* In any case parameters are received through a HTML FORM, hence data are retrieved using the POST method:
	* values written by the user are stored in INPUT fields named "field<n>".
	* This page retrieves all the input parameters and executes the UPDATE or INSERT statement, then shows
	* the result of the operation.
	*/

	include '../include/session_header.php'; 		// Including pages that take care of the session and database  
	include '../include/database_header.php' ;		// Managing database connections  
	include '../include/users_DAO.php';				// Including pages managing the customers table (DAO layer)
	include '../include/display_header.php' ;		// Defining layout, images and loading the left menu
?>

<script language="JavaScript">
// Appending the users CSS at run-time
linkElement 		= document.createElement("link") ;
linkElement.rel 	= "stylesheet" ;
linkElement.href 	= "../css/users.css" ; 
document.head.appendChild(linkElement) ;
</script>

<?php
	// 1. Recognizing the action selected by the user (HTML FORM)
	$code 	= $_POST['code'] ;				// Code of customer
	$quest 	= $_POST['quest'] ;				// Type of operation
	if ( isset($_SESSION['USER_VIEW']) ) 	$mode = $_SESSION['USER_VIEW'] ;
	else									$mode = 1 ;
	if 		($code == 0) 					$operation = "INSERIMENTO" ;
	elseif 	($quest == 1) 					$operation = "MODIFICA" ;
  
	// 2. Customizing table layout
	$rows 		= 18 ;
	$columns 	= 2 ;
	$span 		= $columns + 1 ;  
	include 	'../include/users_labels.php' ;
	print "<p class='td_customers_title'>$operation $labelTitle</p>" ;
	print "<br/>" ;

	// 3. Retrieving data from the POST HTTP.
	// Moreover we manage the ADMIN checkbox (16th field), which exists only if passed
	$values = array() ;
	$values[16] = 0 ;							
	foreach ($_POST as $row => $value) {
		$index = substr($row,5,6) ;
		if (substr($row,0,5) == "field") 		$values[$index] = $value ;
		if (($value == "on") && ($index == 16)) $values[$index] = 1 ;
		// Keep for testing or debug
		// print "Received $row ($index) = $value<br/>" ;
	}
  
	// 4. Updating user's data in the database
	if ($code == 0) 		$done = insertCustomer($values) ;
	elseif ($quest == 1) 	$done = updateCustomer($code, $values) ;
	$error = mysql_errno() ;
	print "<p class='centered' style='width:250px;'>" ;
	if (($error == 0) && ($done == TRUE)) {
		print "Operazione eseguita con successo" ;
		// Refreshing page numbers
		formatPage($mode, "", "users") ;
	}
	else {
		print "Si &egrave; verificato un problema tecnico: operazione fallita.<br/>" ;
		print "Esiste gi&agrave; una scheda con questo numero di codice!" ;
	}
	print "</p>" ;
?>

<table id="customer_data">
<tr>
  <td class="td_customers_title" colspan="<?php print "$span" ?>">
  SCHEDA <?php print $labelCaption ; ?>
  </td>
</tr>
  
<?php
	// 5. Showing modification
	$lines = 0 ;
	if ($code > 0) 	$recordSet = getCustomer($code) ; 
	else 			$recordSet = getCustomer($values[0]) ;
	while ($row = mysql_fetch_array($recordSet, MYSQL_BOTH)) { 
		$lines += 1 ;
		for ($index = 0; $index < $rows ; $index++) {
			print "<tr>\n" ;
			print "\t<td class='td_customers_label'>&nbsp;$customersLongName[$index]</td>\n" ;
			print "\t<td class='td_customers_data'>" ;
			if 		($customersLongName[$index] == "Password") 			print str_repeat("*", 3) ;
			elseif 	($customersLongName[$index] == "Amministratore") 	print (($row[$index] == 1)?"Si":"No") ;
			else print "&nbsp;$row[$index]" ;
			print "</td>\n" ;
			print "</tr>\n";
		}
	} // End of while
	releaseAll();
?>

</table>

<br/><?php include 'users_goback.php' ;  ?><br/>
  
<?php include '../include/display_footer.php' ?>